<?php

$offset = 60*60*24*60;
$ExpStr = "Expires: ".gmdate("D, d M Y H:i:s",time() + $offset)." GMT";
$LmStr = "Last-Modified: ".gmdate("D, d M Y H:i:s",filemtime(__FILE__))." GMT";

header("Cache-Control: public");
header("Pragma: cache");
header($ExpStr);
header($LmStr);
header("Content-type: text/css");
/*
 * The following include file contains the definitions of the classes used and referenced in both the
 * plugin's PHP script and javascript. To minimize having to make changes in more than one code
 * location, PHP is used here to make the necessary class name substitutions.
 */
include('../includes/navtinc.php');
?>

/*
Plugin Name: NAVT Word Press Plugin
Plugin URI: http://www.gbellucci.us
File: NAVT.css.php
Author: Greg A. Bellucci
Author URI: http://www.gbellucci.us
*/

/**
 * NAVT Word Press Plugin
 * Copyright (c) 2007 Greg A. Bellucci/Atalaya Studio
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software
 * and associated documentation files (the "Software"), to deal in the Software without restriction,
 * including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or substantial
 * portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
 * LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * @package NAVT Word Press Plugin
 * @author Greg A. Bellucci <greg[AT]gbellucci[DOT]us
 * @copyright Copyright &copy; 2006-2007 Greg A. Bellucci
 * @license http://www.opensource.org/licenses/mit-license.php The MIT License
 */

.wrap {
    font-family: 'Trebuchet MS', Verdana, Arial, Helvetica;
    min-width:800px;
}

* html {
    overflow:visible;
}

li, dd {
    margin:0;
}

p, li, dl, dd, dt {
    line-height:normal;
}

#errMsg {
    color:#ff0000;
    padding-bottom:10px;
}

.errbox {
    background-color: #FFCA6F;
    border: 1px solid #ff0000;
}

.NAVT-block {
    background:#fff;
    border:1px solid #aaa;
    margin: 1em 270px 1em 1em;
    padding: .5em;
}

.catopts {
    text-align: left;
}

.<?php e_(CLS_STATIONARY_GROUP);?>,
.<?php e_(CLS_MENUGROUP);?> {
    float:left;
    position: relative;
    left: 0;
    top: 0;
    margin: .2em;
    width:195px;
}

#<?php e_(ID_DEFAULT_GROUP.ID_SFX_FDIV);?> {
    /* height: 300px;
    overflow:scroll;
    clear: both;
    width:180px; */
}

.<?php e_(CLS_STATIONARY_GROUP);?>,
.<?php e_(CLS_MENUGROUP);?> {
    border: 1px solid #ccc999;
    border-top: none;
}

.<?php e_(CLS_MENUGROUP_HANDLE);?> {
    cursor:move;
}

#pluginsidebar {
    float:right;
    padding:5px;
    width:260px;
}

.<?php e_(CLS_STATIONARY_GROUP);?> h3,
.<?php e_(CLS_MENUGROUP);?> h3 {
    line-height: 32px;
	font-size:1.0em;
	/* font-variant:small-caps; */
	letter-spacing: 1px;
	margin:0;
	text-align:center;
}

.<?php e_(CLS_STATIONARY_GROUP);?> h3,
.<?php e_(CLS_MENUGROUP);?> h3 {
    color:#fff;
}

img.<?php e_(CLS_MENUITEM_HANDLE);?> {
	cursor:move;
    height:16px;
    margin:0.3em;
    width:20px;
}

.<?php e_(CLS_PGCT);?> {
    border: 1px solid #666;
}

.<?php e_(CLS_PGCT);?> h4 {
    display:inline;
	/*font-family: Verdana, 'Trebuchet MS', Sans-Serif;*/
	font-size:1em;
	/* letter-spacing: .1em; */
	/* font-variant:small-caps; */
	font-weight: normal;
	text-align: left;
	margin-left:5px;
}

.<?php e_(CLS_PGCT);?> h4 a:visited,
.<?php e_(CLS_PGCT);?> h4 a {
    color:#333;
    padding-bottom: .3em;
    border:none !important;
}

.<?php e_(CLS_PGCT);?> h4 a:hover {
    color: #000;
    text-decoration: underline;
}

h4.subtitle {
    padding: 5px 0;
    margin: 0;
    font-size: 1em;
    font-weight: normal;
    color:#3B52BF !important;
}

.<?php e_(CLS_PGCT);?> img {
    margin: .3em 0 0 .3em;
}

.<?php e_(CLS_BOX_OPEN);?> {
    border: 1px solid #600000;
}

.<?php e_(CLS_FDIV);?> {
	list-style-type:none;
	padding: .1em;
	margin: 0px;
	/* width: 178px; */
	width:195px;
	min-height:1em; /* creates space at top */
}

.<?php e_(CLS_FDIV);?> li{
	font-size:.85em;
	margin: .1em;
	padding:0 0 .3em .5em;
}

/* Dummy place-holder entry in the menu group
 */
.<?php e_(CLS_FDIV);?> li.ph {
    width:98%;
	font-size: 1.5em;
	height:1em;
	margin: 0px;
	padding: 0px;
}

.<?php e_(CLS_DCON);?>,
.<?php e_(CLS_MDELE);?>,
.<?php e_(CLS_IMENU);?>,
.<?php e_(CLS_MMENU);?> {
    /* border-top:1px solid #666; */
    font-size:0.95em;
    left:0px;
    margin-top:0.8em;
    position:relative;
    top:0;
    width:100%;
    /* don't margin bottom */
}

.<?php e_(CLS_MDELE);?> h4 {
    text-align: center;
    font-weight: normal;
    font-variant: small-caps;
    padding: 2px;
}

.<?php e_(CLS_DCON);?> fieldset,
.<?php e_(CLS_MDELE);?> fieldset,
.<?php e_(CLS_MMENU);?> fieldset {
    padding:.2em;
    padding-top: .5em;
    /* margin-bottom:.5em; */
    border-bottom: 1px solid #666;
}

.<?php e_(CLS_MDELE);?> {
    border: 1px solid #ff0000;
    background-color: #fefefe;
    color: #666;
    width:99%;
}

.<?php e_(CLS_MMENU);?> input[type="text"] {
    margin-top: 20px !important;
}

.<?php e_(CLS_DCON);?> p,
.<?php e_(CLS_MDELE);?> p,
.<?php e_(CLS_IMENU);?> p,
.<?php e_(CLS_MMENU);?> p {
    line-height: normal;
    /* float:right; */
    position: relative;
    top: 0;
    left: 0;
    padding-top:.4em;
    padding-right: .3em;
    padding-left: .3em;
    margin:0;
}

fieldset legend {
    font-size: .95em;
    font-weight: 500;
    color: #000;
}

fieldset.pluginreset {
    padding: 10px;
    background-color: #FFDFDF;
}

.<?php e_(CLS_IMENU);?> legend {
    padding-top: 5px;
    font-size:1em;
    color: #3B52BF;
}

.<?php e_(CLS_IMENU);?> p.info,
.<?php e_(CLS_MMENU);?> p.info {
    /* item name */
    float:none;
    font-size: 1em;
    color: #3B52BF;
}

.<?php e_(CLS_DCON  . ' p.' . CLS_MSG); ?>,
.<?php e_(CLS_IMENU . ' p.' . CLS_MSG); ?>,
.<?php e_(CLS_MMENU . ' p.' . CLS_MSG); ?> {
    float:none;
    text-align:center;
    border-top:1px solid #aaa;
    font-size:1.1em;
    margin-top:0.5em;
}

.<?php e_(CLS_MMENU . ' p.' . CLS_MSG); ?> {
    font-size: 1em;
}

.<?php e_(CLS_DCON);?> a,
.<?php e_(CLS_MDELE);?> a,
.<?php e_(CLS_IMENU);?> a,
.<?php e_(CLS_MMENU);?> a {
    background:transparent;
    display:block;
    overflow:hidden;
    position:relative;
    left: 0;
    top: 0;
    border:0;
    /* don't pad on the bottom */
}

 .<?php e_(CLS_IMENU);?> input[type=text],
 .<?php e_(CLS_MMENU);?> input[type=text] {
    margin-top: .2em;
    font-family: "Lucida Grande","Lucida Sans Unicode",Tahoma,Verdana;
    font-size: 1em;
    color: #000;
    background: #fff;
 }

 .<?php e_(CLS_DCON);?>  img,
 .<?php e_(CLS_MDELE);?> img,
 .<?php e_(CLS_MMENU);?> img,
 .<?php e_(CLS_IMENU);?> img {
    padding: 5px;
    padding-right: 15px;
 }

 .<?php e_(CLS_IMENU);?> legend p {
    padding-top: 1em;
    font-weight: 500;
 }

 .okcan {
    position: relative;
    top: 0;
    left: .1em;
    height: 22px;
    /* don't pad/margin */
 }

 .okcan p {
    float:right;
    padding-right: 3px;
    top: 0;
    left: 0;
    position: relative;
 }

 div.options_wrapper {
    position:relative;
    top: 0;
    left: 0;
    min-height:1%;
 }

 div.helpdiv {
    height:1em;
    position:absolute;
    right:0px;
    top:3px;
    width:25px;
}

 a.<?php e_(CLS_DCON_OK);?>, a.<?php e_(CLS_DCON_CAN);?>,
 a.<?php e_(CLS_MDELE_OK);?>,a.<?php e_(CLS_MDELE_CAN);?>,
 a.<?php e_(CLS_MLINK_OK);?>,a.<?php e_(CLS_MLINK_CAN);?>,
 a.<?php e_(CLS_ILINK_OK);?>,a.<?php e_(CLS_ILINK_CAN);?>,a.<?php e_(CLS_ILINK_DEL);?>,
 a.<?php e_(DELBUTTON);?>,
 a.<?php e_(OKBUTTON);?>,
 a.<?php e_(CANBUTTON);?> {
    background: url(<?php e_(IMG_CANCEL);?>) no-repeat top left;
    height:16px;
    padding-right: 5px;
 }

 a.<?php e_(CLS_DCON_OK);?>,
 a.<?php e_(CLS_MDELE_OK);?>,
 a.<?php e_(CLS_MLINK_OK);?>,
 a.<?php e_(CLS_ILINK_OK);?>,
 a.<?php e_(OKBUTTON);?> {
    background: url(<?php e_(IMG_OK);?>) no-repeat top left;
 }

 a.<?php  e_(CLS_ILINK_DEL);?>,
 a.<?php e_(DELBUTTON);?> {
    background: url(<?php e_(IMG_DELETE);?>) no-repeat top left;
 }

 a.helptip:hover,
 a.<?php e_(CLS_DCON_OK);?>:hover,  a.<?php e_(CLS_DCON_CAN);?>:hover,
 a.<?php e_(CLS_MDELE_OK);?>:hover, a.<?php e_(CLS_MDELE_CAN);?>:hover,
 a.<?php e_(CLS_MLINK_OK);?>:hover, a.<?php e_(CLS_MLINK_CAN);?>:hover,
 a.<?php e_(CLS_ILINK_OK);?>:hover, a.<?php e_(CLS_ILINK_CAN);?>:hover, a.<?php  e_(CLS_ILINK_DEL);?>:hover,
 a.<?php e_(DELBUTTON);?>:hover, a.<?php e_(OKBUTTON);?>:hover, a.<?php e_(CANBUTTON);?>:hover {
    background-position: 0 -16px;
 }

/* Icons
 */
img.<?php e_(CLS_PAGE_ICON);?>    {background: transparent url(<?php e_(IMG_PAGE_ICON);?>) 0 0 no-repeat;}
img.<?php e_(CLS_CAT_ICON);?>     {background: transparent url(<?php e_(IMG_CATEGORY_ICON);?>) 0 0 no-repeat;}
img.<?php e_(CLS_ELINK_ICON);?>   {background: transparent url(<?php e_(IMG_LINK_ICON);?>) 0 0 no-repeat;}
img.<?php e_(CLS_HOME_ICON);?>    {background: transparent url(<?php e_(IMG_HOME_ICON);?>) 0 0 no-repeat;}
img.<?php e_(CLS_ADMIN_ICON);?>   {background: transparent url(<?php e_(IMG_ADMIN_ICON);?>) 0 0 no-repeat;}
img.<?php e_(CLS_DIVID_ICON);?>   {background: transparent url(<?php e_(IMG_DIVID_ICON);?>) 0 0 no-repeat;}
img.<?php e_(CLS_DRAFTPAGE);?>    {background: transparent url(<?php e_(IMG_DRAFT_ICON);?>) 0 0 no-repeat;}
img.<?php e_(CLS_AUTHOR_ICON);?>  {background: transparent url(<?php e_(IMG_AUTHOR_ICON);?>) 0 0 no-repeat;}
img.<?php e_(CLS_PRIVATE);?>      {background-position: 0 -18px;}


/* Menu group color schemes
 */
<?php
$out = '';
$scheme = array(

    0 => array( 'bkg' => 'b9b9b9', 'fg' => 'ffffff'),  // black
    1 => array( 'bkg' => 'eebbab', 'fg' => 'e49378'), // red
    2 => array( 'bkg' => 'FCD594', 'fg' => 'fcd689'), // orange
    3 => array( 'bkg' => '95C6FF', 'fg' => 'a0bdf9'), // blue
    4 => array( 'bkg' => '9FFFA3', 'fg' => '9fcf87'), // green
    5 => array( 'bkg' => 'e1c3e1', 'fg' => 'cf88cf')  // purple
    );

for( $n = 0; $n <= SCHEME_LIMIT; $n++ ) {

    $ypos = ($n * -32);
    $css_group = sprintf(".%s ", ($n > 0) ? CLS_GROUP_SCHEME.$n : CLS_STATIONARY_GROUP);
    $css_h3    = sprintf("%s h3", $css_group);
    $css_item  = sprintf("%s .%s", $css_group, CLS_PGCT);

    $out .= sprintf("%s {\n", $css_group);
    $out .= sprintf("   background-color: #%s;}\n", $scheme[$n]['bkg']);
    $out .= sprintf("   %s {\n", $css_h3);
    $out .= sprintf("     background: transparent url(../images/btn.jpg) repeat-x 0 %dpx !important; }\n", $ypos);
    $out .= sprintf("   %s .%s,\n   %s .menu li:hover,\n   %s .%s {\n", $css_group, CLS_BOX_OPEN, $css_group, $css_group, CLS_MMENU);
    $out .= sprintf("     background: transparent url(../images/ibk.jpg) 0 %dpx repeat-x !important; }\n", ($n * -400));
    $out .= sprintf("   %s {\n", $css_item);
    $out .= sprintf("     background: transparent url(../images/ibk.jpg) 0 %dpx repeat-x !important; \n", ($n * -400));
    $out .= sprintf("      \n}\n\n\n");
}
e_($out);
?>

ul.<?php e_(CLS_DROPZONE . ' ' . CLS_MSORT_TAG . '.' . CLS_DRAFTPAGE); ?> {
    background: #EFECE0 !important;
}

/* Change bars */
.<?php e_(CLS_CHANGE);?>,
.<?php e_(CLS_MOVED);?> {
    border-left: .18em solid #cc3300;
}

label {
    padding-top:3px;
    padding-bottom:3px;
    text-align:left;
    color: #3B52BF;
}

textarea, input[type=text], select {
	color: #000;
	font-size: 1em;
	margin: 1px;
	padding: 3px;
	width: 90%;
}

.selbox {
	font: 1em "Lucida Sans Unicode", Arial, sans-serif;
	padding: 0px;
}

.menu {
  font-size: .85em;
  cursor: pointer;
  padding:0.1em 3em 0.1em 0.5em;
  width:auto;
}

.menu ul {
    border-left: 1px solid #333;
    color: black;
    display: none;
    left: 15px;
    top:0;
    list-style-type: none;
    margin: 0.1em 0pt 0pt;
    padding: 2px;
    position:relative;
}

.menu ul li {
    display: block;
    padding: 0.2em;
    padding-left: 3px;
}

.menu li:hover,
.menu:hover ul {
    display: block;
    margin: 0;
}

.boxed {
    border: solid 1px #666;
}

code {
    font-family: "Courier New";
    font-size: .85em;
}

/* fixes issue with effects */
.iteminfo {
    bottom:0px !important;
}

/*                           */
/* --------- 95.38 --------- */
/*
#navt_filter {
    font-size: 1.1em;
}
                         */
#navt_filter h3 {
font-variant:small-caps;
font-weight:normal;
margin-bottom:0;
padding-bottom:0;
padding-left:5px;
}

/* group menu structure */
div.group-menu h4 {
margin:0;
padding: 5px 0 5px 5px;
font-weight: normal;
font-variant:small-caps;
font-size:.95em;
}

div.group-menu h4 a,
div.group-menu h4 a:visited {
text-decoration:none;
border-bottom:none !important;
color:#888;
}

div.group-menu h4 a:hover {
color:#333;
border-bottom: none !important;
/* border-bottom:#777; */
}

div.group-menu ul {
margin: 8px;
padding: 3px 0 3px 15px;
border: 1px solid #333;
}

div.group-menu ul li {
font-variant:small-caps;
list-style: none;
}

ul.mlist li a,
ul.mlist li a:visited {
color: #888;
border-bottom:none;
}

ul.mlist li a:hover {
color:#333;
}

img.spin {
width:32px;
height:32px;
float:left;
}

.<?php e_(CLS_DELETED);?> {
    display:none !important;
}

img.avatar {
border:1px solid #777777;
padding:2px !important;
position:absolute;
right:5px;
top:-10px;
width: 32px;
height:32px;
}

.disabled,
.disabled_button {
color: #aaa !important;
}

/* item hierarchy controls */
.<?php e_(CLS_FDIV); ?> span.hier {
top: 5px;
right: 0;
list-style: none;
margin: 0;
margin-right: 0px;
position:absolute;
}

.<?php e_(CLS_FDIV); ?> span.hier p {
font-size: 15px;
list-style: none;
display:inline;
overflow:hidden;
padding: 0;
margin: 0;
padding-top: 2px;
}

.<?php e_(CLS_FDIV); ?> span.hier p.indent a {
background: url('<?php e_(IMG_PLUS);?>') no-repeat top left;
}
.<?php e_(CLS_FDIV); ?> span.hier p.outdent a {
background: url('<?php e_(IMG_MINUS);?>') no-repeat top left;
}

.<?php e_(CLS_FDIV); ?> span.hier p.outdent a img,
.<?php e_(CLS_FDIV); ?> span.hier p.indent a img {
width: 7px !important;
height: 16px !important;
padding:0 2px;
margin:0;
}

.<?php e_(CLS_FDIV); ?> span.hier p.indent a img {
padding-right: 5px;
}

.<?php e_(CLS_FDIV); ?> span.hier p.indent a,
.<?php e_(CLS_FDIV); ?> span.hier p.outdent a {
margin: 0;
padding: 0;
border: none;
}

.<?php e_(CLS_FDIV); ?> span.hier p.outdent a:hover,
.<?php e_(CLS_FDIV); ?> span.hier p.indent a:hover {
background-position: 0 -16px;
}

/* Item hierarchy */
.fdiv li.mi.lv0 {
margin-left: 0px !important;
}

/* Level indentations */
.fdiv li.mi.lv1 { margin-left: 10px !important; }
.fdiv li.mi.lv2 { margin-left: 20px !important; }
.fdiv li.mi.lv3 { margin-left: 30px !important; }
.fdiv li.mi.lv4 { margin-left: 40px !important; }

input.cbx {
    padding: 0 !important;
    margin: 0 !important;
    /* margin-bottom: 1px !important; */
    border: 1px solid #ccc;
}

.mg span.gspin {
position:absolute;
right:3px;
top:2px;
}

.cant-see-me {
display:none;
}

div.tipwin {
    color: #000;
    font-size: 1em;
    padding: 5px;
    font-family: Georgia, "Times New Roman", Times, serif;
}

div.tipwin h3 {
    font-size: 1.3em;
    border-bottom: 1px solid #888;
    color: #3F0100;
}

div.tipwin dt {
    color: blue;
    padding: 10px 5px;
    font-size: 1.2em;
    font-variant: small-caps;
    text-decoration: underline;
}

div.tipwin dd {
    padding-left: 15px;
    padding-top: 5px;
}

div.tipwin dd.exmp {
    padding-left: 20px;
    padding-bottom: 5px;
    font-size: .95em;
    color: blue;
}

div.tipwin ul li {
    padding-bottom: 5px;
}

div.tiplinks {
    font-family: "Lucida Grande","Lucida Sans Unicode",Tahoma,Verdana;
    position: absolute;
    top: 1.5em;
    right: 1.5em;
}

div.tiplinks input.disable {
    color: #888;
}

div.tiplinks ul li {
    list-style: none;
    display: inline;
    padding: 5px 3px;
}

div.tiplinks ul li a {
    border: 1px solid #888;
    padding: 2px 5px;
}

div.tiplinks ul li a:hover {
    border: 1px solid #333;
    background-color: #efefef;
}

div.tiplinks ul li a.current {
    border: 1px solid #333;
    background-color: #efefef;
}

a.helptip {
    height:15px;
    background:transparent url(<?php e_(IMG_HELP_ICON);?>) no-repeat top left;
 }

div.notation {
    background-color: #DFD999;
    border:1px solid #333;
    font-size:0.95em;
    padding:5px;
    margin:5px 30px;
    text-align: center;
 }

 div.notation p {
    padding: 2px;
 }

 div.notation h4 {
    font-size: 1em;
    font-variant: small-caps;
    text-decoration: underline;
    padding: 0;
    margin: 4px 0;
 }

 /* link examples */
 div.extsg {
    /* this holds a link with a side graphic */
    position:relative;
    height: 50px;
    width: 200px;
    padding: 10px;
    margin-left: 30px;
 }

 img.sgraphic {
    /* side graphic background */
    width: 50px;
    height: 50px;
    background: url(../images/example.jpg) no-repeat center center;
    border: 1px solid #ccc;
    padding: 5px;
 }

 a.aextsg {
    border:none;
 }

 span.stext {
    /* anchor for side graphic */
   left:80px;
   position:absolute;
   top:35px;
 }

 /* text over graphic */
 a.extog {
    background:transparent url(../images/blue.jpg) no-repeat scroll center top;
    border:medium none;
    display:block;
    height:31px;
    width:164px;
    text-align:center;
    padding-top:5px;
    color:#3684AF;
 }

 a.extog:hover {
    color: #000;
 }

 div.dgraphix img.igraphix {
    background:transparent url(../images/graphic.jpg) no-repeat scroll center top;
    border-color: #ccc;
    width:225px;
    height:64px;
 }

 div.dgraphix a.agraphix span {
    margin-left: -9999px;
 }

 div.ex_wrapper {
    margin-left:30px;
    padding:10px 5px 5px 0pt;
 }

 /* avatar example */
 div.avex ul li {
    position: relative;
    list-style: none;
    margin-bottom: 15px;
 }

 div.avex ul li div.detail_wrapper {
    font-family: "Lucida Grande","Lucida Sans Unicode", Tahoma, Verdana;
    font-size:0.90em;
    left:50px;
    position:absolute;
    top:0;
    padding-left: 10px;
 }

 a.avlink {
 /* link to users archive */
 text-decoration: none;
 border: none;
 display:block;
 }

 a.avlink img.av {
 /* the avatar */
    height: 32px;
    width:32px;
    padding: 4px;
    border: 1px solid #ccc;
 }

 div.avex ul li div.detail_wrapper a.avemail {
    /* email address */
    padding: 0;
    text-decoration: none;
    border:none;
 }

 div.avex ul li div.detail_wrapper p.avbio {
    /* bio statement */
    margin: 0;
 }

 div.avex ul li div.detail_wrapper a.avweb {
    /* web address */
    padding: 0;
    text-decoration: none;
    border:none;
 }

 input.cbutton {
 /* close tip */
 border: 1px solid #ccc;
 }

 input.cbutton.cb_in {
    border: 1px solid red;
 /* rollover */
 }

 input.pbutton {
 /* tip pages */
  border: 1px solid #ccc;
 }

 input.pbutton.pb_in {
 /* rollover */
  border: 1px solid blue;
 }

 select.avselect {
    width: 95%;
 }

 select#vuselect {
    width: auto;
 }

 /* -------- 95.42 --------- */
 p#pm1, p#pm2,p#pm3,p#pm4,p#pm5 {
    font-size: .85em;
    padding:0px 0px 2pt;
    margin:0;
    color: #888;
 }

 p.last_updated {
    color: #333 !important;
    padding:0px 0px 6pt;
 }

 .dbx-content p {
    padding: 5px 0;
    margin: 0;
    font-size: 1em;
 }

 .error {
    text-align: center;
    padding: 3px;
 }
 span.foldicon.close {
    background: url(../images/ikon_arrow_up.gif) no-repeat top left;
    position: absolute;
    top: 35px;
    right: 10px;
    width: 16px;
    height: 16px;
    }
        span.foldicon a img {
        width: 16px;
        height: 16px;
        }
        span.foldicon a {
            border: none;
            text-decoration: none;
        }
span.foldicon.open {
    background: url(../images/ikon_arrow_down.gif) no-repeat top left;
    position: absolute;
    top: 35px;
    right: 10px;
    width: 16px;
    height: 16px;
}
small {
    font-size: .9em;
}

.dbx-handle {
    font-size:1em;
    padding:0 1em 2px;
}