<?php
/*
Plugin Name: NAVT Word Press Plugin
Plugin URI: http://www.gbellucci.us
Description: Administration Options (form display)
Author: Greg A. Bellucci
Author URI: http://www.gbellucci.us

PHP Progressbar credit:
Juha Suni <juha.suni@sparecom.fi>

*/

/**
 * NAVT Word Press Plugin
 * Copyright (c) 2006-2007 Greg A. Bellucci/Atalaya Studio
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software
 * and associated documentation files (the "Software"), to deal in the Software without restriction,
 * including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or substantial
 * portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
 * LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * @package NAVT Word Press Plugin
 * @author Greg A. Bellucci <greg[AT]gbellucci[DOT]us
 * @copyright Copyright &copy; 2006-2007 Greg A. Bellucci
 * @license http://www.opensource.org/licenses/mit-license.php The MIT License
 */
$plugin_url = NAVT::get_url();
$restore_complete = 0;
?>
<style type="text/css">
div.completemsg p { color: #666; font-size: 1.3em; }
div.wrap {font-family: "Trebuchet MS", Arial, Helvetica;}
.center {text-align: center;}
span.uline {text-decoration: underline;}
p.instruct { color: #666; font-size: 1.1em;}
p.padleft { line-height: normal; padding: 5px 0 0 15px; margin: 0 !important;}
p.explain {color: #2F53FF; padding: 0 0 10px 25px; line-height: normal; margin: 0 !important;}
p.warn {font-size: 1.2em; color: #BF001A;}
div.progbar { background: url(<?php echo $plugin_url; ?>/images/bar-bg.gif) no-repeat; height: 60px; width: 514px;	margin: auto; }
div.bitem {padding-top: 10px;padding-left: 7px;text-align: left;}
span.pbox {background-color: #FFFFFF; position: absolute;left: 70%; font-family: "Trebuchet MS", Arial, Helvetica; font-size: 18px; font-weight: bold; color: #999;text-align: center; }
</style>
<?php

// various file upload problems

$err = array(
__('no error [0]'), __('Restore file is too large. [1]'), __('Restore file is too large. [2]'), __('Restore file was only partially uploaded.'),
__('Please select a restore file.'), __('Unknown Error. [5]'), __('A temp directory is missing on your server.'), __('Cannot write to temporary directory on server.'),__('File upload failed. Restore could not be performed.')
);

// restore result messages
$res = array(
__('Restore completed'), __('Incorrect file type; file must be an XML file.'), __('Restore file is empty.'),
__('Restore failed, file is corrupt.'), __('Restore failed, file is incomplete.')
);

if( isset( $_REQUEST['navt_action'] ) && $_REQUEST['navt_action'] == 'restore' ) {
    $error = $_FILES['restore_file']['error'];
    if( !empty($error) && $error != 0 ) {
        $_GET['message'] = $err[intval($error)];
    }
    else {
        $restore_how      = ((isset($_POST['restore_how']) ) ? $_POST['restore_how'] : RESTORE_IGNORE);
        $match_title      = ((isset($_POST['MATCH']['title']) ) ? 1: 0 );
        $match_alias      = ((isset($_POST['MATCH']['alias']) ) ? 1: 0 );
        $use_backup_alias = ((isset($_POST['MATCH']['use_backup_alias'])) ? 1: 0);
        $publish_pages    = ((isset($_POST['MATCH']['publish_pages'])) ? 1: 0);
        $doin_the_deed    = 1;
    }
}// end if

if( $doin_the_deed ) {
    // read/parse the restore file
    $ar = array();
    $retcode = navt_restore_readparse($ar);
    if( $retcode != 0 ) {
        // encountered an error of some kind while parsing the file
        $doin_the_deed = 0;
        $_GET['message'] = $res[$retcode];
    }
    else { ?>

    <div class="wrap">
        <h2><?php _e('NAVT Restore');?></h2>
        <p>Restoring <?php echo $_FILES['restore_file']['name'];?></p>
        <div class="progbar">
            <div class="bitem">
            <?php
            // start the restore
            ob_end_flush();
            flush();
            $pp = $pl = $iter = 0;
            $inc = 100/count($ar);
            $res_map = array();

            foreach( $ar as $backup_item ) {
                $step1 = navt_find_restore_item($backup_item, $match_title, $match_alias, $use_backup_alias, $publish_pages );
                $step2 = navt_restore_item($step1, $restore_how);
                if(is_array($step2)) $res_map[] = $step2;
                update_progress(&$iter, $inc, &$pl, $plugin_url);
                flush();
            }

            foreach( $res_map as $itm ) {
                $key_map[] = array('key' => $itm[TYP] . '/' . $itm[IDN] . '/' . $itm[TTL], 'item' => $itm);
            }

            $cur_map = NAVT::load_map();
            if(NAVTdbg()) navt_write_debug(NAVT_RESTORE, sprintf("n\current map\n"), $cur_map);
            foreach( $cur_map as $itm ) {
                $key_map[] = array('key' => $itm[TYP] . '/' . $itm[IDN] . '/' . $itm[TTL], 'item' => $itm);
            }

            $keys = $nmap = array();
            for( $i = 0; $i < count($key_map); $i++ ) {
                $key = $key_map[$i]['key'];
                $item = $key_map[$i]['item'];
                if( !in_array($key, $keys) ) {
                    $keys[] = $key; $nmap[] = $item;
                }
            }
            if(NAVTdbg()) navt_write_debug(NAVT_RESTORE, sprintf("keys\n"), $keys);
            if(NAVTdbg()) navt_write_debug(NAVT_RESTORE, sprintf("nmap\n"), $nmap);
            $restore_complete = 1;
        } ?>

        </div> <?php // bitem ?>
    </div> <?php // progbar ?>
    <?php

    if( $restore_complete && count($nmap) > 0 ) {
        NAVT::update_option(SERIALIZED_MAP, $nmap);
        print '<div class="completemsg"><p>&bull;&nbsp;'.__('Restore Complete').'&nbsp;&bull;</p></div>';
        die();
    } ?>

<?php } // end if $doin_the_deed

    if( !$doin_the_deed ) {
// Displayed only if we're not doing the actual restore ?>
<?php if (isset($_GET['message'])) : ?>
<div id="message" class="updated fade"><p><?php echo $_GET['message']; ?></p></div>
<?php endif; ?>
<div class="wrap">
<h2><?php _e('NAVT Restore');?></h2>
<form id="navt_restore" onSubmit="" method="post" enctype="multipart/form-data">
<p class='instruct'><?php _e('NAVT Backup Restoration enables you to reconstruct a set of previously created navigation groups by loading a backup file created by the NAVT plugin. The information stored in the backup is merged with your current set of navigation items. The data merge is controlled by selecting one of the options in Step Two.');?>
<h3><?php _e('Terminology');?></h3>
<p class="instruct"><?php _e('A ');?><span class="uline"><?php _e('matched item');?></span><?php _e(' is defined on this page as a navigation item that exists in both the backup and within your current configuration. For example, a page or a category that is now in use on your web site that also existed at the time the backup was created. An ');?><span class="uline"><?php _e('unmatched item');?></span><?php _e(' is a page, category or other item that exists in the backup but no longer exists on your web site. ');?></p>
<p class="warn center"><?php _e('It is recommended that you backup any existing navigation groups before proceeding.');?></p>
<hr />

<h3><?php _e('Step One');?></h3>
<p class='instruct'><?php _e('Select the file from your computer that contains the NAVT backup you wish to restore. This must be a backup file in XML format that was created by the NAVT plugin.');?></p>
<p class='padleft'><?php _e('File Name: ')?><input type="file" id="restore_file" name="restore_file" size="40" maxlength="80" value="" class="button"></p>
<br />
<hr />
<h3><?php _e('Step Two');?></h3>
<p class='instruct'><?php _e('Select one of the merge options below.');?></p>
<fieldset>
<p class='padleft'><input type="radio" name="restore_how" value="<?php echo RESTORE_MERGE;?>" select="selected" /> <?php _e('Merge with discard (Default).');?></p>
<p class="explain"><?php _e('Matched items are merged with existing navigation groups. Unmatched items are discarded.');?></p>

<p class='padleft'><input type="radio" name="restore_how" value="<?php echo RESTORE_CREATE_MERGE;?>" /> <?php _e('Create and merge unmatched items.');?></p>
<p class="explain"><?php _e('Pages, categories or users are automatcially created for unmatched items.');?><em> <?php _e('(Useful for creating new web sites from a backup)');?></em></p>
<p style='padding: 0 0 0 35px; margin: 0 !important;'><input type="checkbox" name="MATCH[publish_pages]" value="1" /> <?php _e('Publish pages created from restored page items.');?><em><?php _e(' (Default is to create a draft)');?></em></p>
</fieldset>
<hr />

<h3><?php _e('Step Three');?></h3>
<p class='instruct'><?php _e('Item matching is primarily determined by the identifier assigned to an item by the database when the item was created. For example, a page item in the backup that has an identifier that is equal to a page identifier in your current set of pages is considered loosely matched. However, you can indicate that stricter matching be used by checking one or both of the options below.');?></p>
<p class='padleft'><input type="checkbox" name="MATCH[title]" value="1" /> <?php _e('Backup item title must also equal matched item title.');?></p>
<p class='padleft'><input type="checkbox" name="MATCH[alias]" value="1" /> <?php _e('Backup alias name must also equal matched item alias.');?></p>
<h4><?php _e('Additional Options');?></h4>
<p class='padleft'><input type="checkbox" name="MATCH[use_backup_alias]" value="1" /> <?php _e('Use the alias name in the backup as the ');?><span class="uline"><?php _e('preferred alias name');?></span><em><?php _e(' (Default is current alias)');?></em></p>
<p class="submit"><input type="submit" id="navt_restore_plugin" name="navt_restore_plugin" value="<?php _e('Begin Restore &raquo;');?>" class="button delete"></p>
<input type='hidden' name='navt_action' value='restore' />
</form>
<?php } ?>
</div> <?php // wrap ?>
<?php

/**
 * Read/Parse a restore file
 */
function navt_restore_readparse(&$ar) {

    $retcode = 0;

    if( isset($_FILES['restore_file'])) {
        $file = $_FILES['restore_file']['tmp_name'];
        $user_file = $_FILES['restore_file']['name'];
        $mime_type = $_FILES['restore_file']['type'];

        if( $mime_type != 'text/xml' ) {
            $retcode = 1;// wrong type of file?
        }
        elseif(filesize($file) == 0 ) {
            $retcode = 2;// empty?
        }
    }

    if( $retcode == 0 ) {
        $parser_error = $entries = 0;
        $file_contents = file_get_contents($file);
        $p = xml_parser_create('UTF-8');
        $result = xml_parse_into_struct($p, $file_contents, $vals, $index);

        if( !$result ) {
            $parser_error = 1;
            if(NAVTdbg()) navt_write_debug(NAVT_RESTORE, sprintf("XML restore parse error: %s\n",
            xml_error_string(xml_get_error_code($p))));
            $retcode = 3; // corrupt?
        }

        xml_parser_free($p);

        if( !$parser_error ) {
            if(NAVTdbg()) navt_write_debug(NAVT_RESTORE, sprintf("* Parsing restore file *\n"));
            $in_map = $in_item = 0;
            $this_version = $installed_version = null;
            $cur_item = array();

            foreach ($vals as $k => $v) {

                if( $v['tag'] == 'NAVT' ) {

                    if( $v['type'] == 'open' ) {
                        $ar[] = array('version' => $v['attributes']['MAJOR_VERSION'] . $v['attributes']['MINOR_VERSION']);
                        $in_map = 1;
                    }
                    elseif( $v['type'] == 'close' ) {
                        $in_map = 0;
                    }
                    continue;
                }

                if( $in_map ) {

                    if( $v['tag'] == 'ITEM' ) {
                        if( $v['type'] == 'open' ) {
                            $in_item = 1;
                            $cur_item = array();
                        }
                        elseif( $v['type'] == 'close' ) {
                            $in_item = 0;
                            $args = array(
                            'grp' => $cur_item['GRP'], 'typ' => $cur_item['TYP'],
                            'idn' => $cur_item['IDN'], 'ttl' => $cur_item['TTL'],
                            'nme' => $cur_item['NME'], 'opt' => $cur_item['OPT'],
                            'ext' => $cur_item['EXT'], 'lvl' => $cur_item['LVL'],
                            'ex2' => $cur_item['EX2']
                            );
                            $ar[] = navt_format_menu_item($args);
                            if(NAVTdbg()) navt_write_debug(NAVT_RESTORE, sprintf("\titem complete:"), $cur_item);
                        }

                        continue;
                    }

                    if( $in_item ) {

                        if(( $v['tag'] == 'GRP' || $v['tag'] == 'TYP' || $v['tag'] == 'IDN' ||
                        $v['tag'] == 'OPT' || $v['tag'] == 'LVL' || $v['tag'] == 'TTL' || $v['tag'] == 'NME' ||
                        $v['tag'] == 'EXT' || $v['tag'] == 'EX2') && $v['type'] == 'complete') {
                            $t = $v['value'];
                            if( $v['tag'] == 'EXT' || $v['tag'] == 'TTL' || $v['tag'] == 'NME' || $v['tag'] == 'EX2' ) {
                                ; // maybe encode?
                            }
                            $cur_item[$v['tag']] = $t;
                            if(NAVTdbg()) navt_write_debug(NAVT_RESTORE, sprintf("\t\titem param: %s, value = %s\n", $v['tag'], $t));
                        }
                    }// end in_item
                }// in_map
            }// end for
            if(NAVTdbg()) navt_write_debug(NAVT_RESTORE, sprintf("* Parsing restore end *\n"));
            if( $in_map || $in_item ) {
                $retcode = 4; // incomplete file?
            }
        }// end if */
    }
    return($retcode);
}

/**
 * Restore items
 *
 * @param array $ar
 */
function navt_restore_item($item, $how) {

    $create_item = 0;
    $ar = false;
    global $current_user, $wpdb;
    $wpdb->hide_errors();
    if(NAVTdbg()) navt_write_debug(NAVT_RESTORE, sprintf("* Checking item from restore array\n"));

    if( $how == RESTORE_CREATE_MERGE ) {
        // create the item

        if( $item[TYP] == TYPE_PAGE ) {

            $opt = intval($item[OPT]);
            if( !$item['publish'] ) {
                if( !($opt & ISDRAFTPAGE) ) $opt |= ISDRAFTPAGE;
            }
            else {
                if( $opt & ISDRAFTPAGE ) {
                    $opt -= ISDRAFTPAGE;
                }
            }
            $item[OPT] = $opt;

            // Post fields as if they had come from the add form
            // NAVT will be expecting these
            $_POST['NAVT']['navgroup'] = $item[GRP];
            $_POST['NAVT']['pagealias'] = $item[NME];
            $_POST['NAVT']['level'] = $item[LVL];
            $_POST['NAVT']['imgclass'] = $item[EXT];
            $_POST['NAVT']['isprivate'] = (($opt & ISPRIVATE) ? 1: 0);
            $_POST['NAVT']['nofollow'] = (($opt & NOFOLLOW) ? 1: 0);
            $_POST['NAVT']['donotuse'] = (($opt & DO_NOT_DISPLAY) ? 1: 0);
            $_POST['NAVT']['linkoptions'] |= (($opt & TEXT_OVER_GRAPHIC) ? TEXT_OVER_GRAPHIC: 0);
            $_POST['NAVT']['linkoptions'] |= (($opt & STANDARD_LINK) ? STANDARD_LINK: 0);
            $_POST['NAVT']['linkoptions'] |= (($opt & TEXT_WITH_SIDE_GRAPHIC) ? TEXT_WITH_SIDE_GRAPHIC: 0);

            // insert the page
            $item[IDN] = wp_insert_post( array(
            'post_type' => 'page',
            'post_title' => $item[TTL],
            'post_name' => $item[TTL],
            'post_content' => 'Temporary page contents',
            'post_date' => current_time('mysql'),
            'post_status' => ($item['publish'] ? 'publish': 'draft')
            ));

            if(NAVTdbg()) navt_write_debug(NAVT_RESTORE, sprintf("\t%s page created '%s',  idn = %s: \n", __FUNCTION__,
            $item[TTL], $item[IDN]));
            $create_item = 1;
        }

        elseif( $item[TYP] == TYPE_CAT ) {
            // insert this category
            $title = $wpdb->escape($itm[TTL]);
            $item[IDN] = wp_insert_category(array(
            'category_nicename' => $item[TTL],
            'cat_name' => $item[TTL]));
            if(NAVTdbg()) navt_write_debug(NAVT_RESTORE, sprintf("\t%s category created '%s', idn = %s: \n", __FUNCTION__,
            $item[TTL], $item[IDN]));
            $create_item = 1;
        }

        elseif( $item[TYP] == TYPE_AUTHOR ) {
            // insert this user but only if it isn't 'admin'
            if( $item[TTL] != 'admin' ) {
                $item[IDN] = wp_insert_user(array(
                'user_login'	=> $item[TTL],
                'user_nicename'	=> $item[TTL],
                'user_url'		=> 'http://',
                'display_name'	=> $item[NME]
                ));
                if(NAVTdbg()) navt_write_debug(NAVT_RESTORE, sprintf("\t%s user created '%s', idn = %s: \n", __FUNCTION__,
                $item[TTL], $item[IDN]));
                $create_item = 1;
            }
        }
        else {
            if( $item[TYP] == TYPE_LINK || $item[TYP] == TYPE_ELINK || $item[TYP] == TYPE_SEP ) {
                $create_item = 1;
            }
            else {
                if(NAVTdbg()) navt_write_debug(NAVT_RESTORE, sprintf("\t%s unknown item! \n", __FUNCTION__), $item);
            }
        }
    }
    else {
        // Possible restore
        if(($item['points'] == $item['score'])) {
            $create_item = 1;
        }
    }

    if( $create_item ) {
        // if items were actually created in the database, the plugin will have created
        // navigation entries for them. These duplicates are filtered in the final output.
        $ar = array();
        $args = array(
        grp => $item[GRP], typ => $item[TYP], idn => $item[IDN],
        ttl => $item[TTL], nme => $item[NME], opt => $item[OPT],
        lvl => $item[LVL], ext => $item[EXT], ex2 => $item[EX2] );
        $ar = navt_format_menu_item($args);
        if(NAVTdbg()) navt_write_debug(NAVT_RESTORE, sprintf("\t%s item added: \n", __FUNCTION__), $ar);
    }
    else {
        if(NAVTdbg()) navt_write_debug(NAVT_RESTORE, sprintf("\t%s item discard \n", __FUNCTION__), $item);
    }

    if(NAVTdbg()) navt_write_debug(NAVT_RESTORE, sprintf("* End item check *\n\n"));
    return($ar);
}

/**
 * Locate and qualify a backup item
 *
 * @param array $fx
 * @param array $backup_itm
 * @param boolean $match_title
 * @param boolean $match_alias
 * @return array
 */
function navt_find_restore_item($backup_itm, $match_title, $match_alias, $use_backup_alias, $publish_pages) {

    $ar = $backup_itm;
    $points = 1 + $match_title + $match_alias;
    $ar['in_db'] = 0;
    $ar['points'] = $points;
    $ar['score'] = 0;
    $ar['publish'] = $publish_pages;
    $opt = intval($ar[OPT]) + 0;

    // locate this item in the current map
    if(NAVTdbg()) navt_write_debug(NAVT_RESTORE, sprintf("* Item search *\n"));
    $citem = NAVT::find_by_id( $backup_itm[TYP], $backup_itm[IDN]);

    if(NAVTdbg()) {
        if( is_array($citem) ) {
            navt_write_debug(NAVT_RESTORE, sprintf("%s: found item returned: %s/%s\n", __FUNCTION__,  $backup_itm[TYP], $backup_itm[IDN]), $citem);
        }
    }

    if( $backup_itm[TYP] == TYPE_CAT ) {
        // Locate this item in the database
        $cat = get_category($backup_itm[IDN]);
        if( is_object($cat) ) {
            $ar['in_db'] = 1;
            $ar[TTL] = str_replace('"', "'", $cat->cat_name);
            $ar['score']++;
            if($match_title) {
                $ar['score'] += (($ar[TTL] == $backup_itm[TTL]) ? 1: 0);
            }
            $ar['score'] += ($match_alias && ($citem != null) && ($backup_itm[NME] == $citem[NME]) ? 1: 0);
        }
    }// end category

    elseif( $backup_itm[TYP] == TYPE_PAGE ) {
        $post = get_page($backup_itm[IDN]);
        if(is_object($post) && $post->post_type == 'page') {
            $ar['in_db'] = 1;
            $ar[TTL] = str_replace('"', "'", $post->post_title);
            $ar['score']++;
            if( $match_title ) {
                $ar['score'] += (($ar[TTL] == $backup_itm[TTL]) ? 1: 0);
            }
            $ar['score'] += ($match_alias && ($citem != null) && ($backup_itm[NME] == $citem[NME]) ? 1: 0);
            if( $post->post_status == 'draft' ) {
                $opt += (($opt & ISDRAFTPAGE) ? 0: ISDRAFTPAGE);
            }
            else {
                if( $opt & ISDRAFTPAGE ) {
                    $opt -= ISDRAFTPAGE;
                }
            }
        }
    }// end page

    elseif( $backup_itm[TYP] == TYPE_AUTHOR ) {
        $userdata = get_userdata($backup_itm[IDN]);
        if( is_object($userdata) ) {
            $ar['in_db'] = 1;
            $username = '' != $userdata->first_name && '' != $userdata->last_name ?
            $userdata->first_name . ' ' . $userdata->last_name : $userdata->user_nicename;
            $ar[TTL] = $userdata->user_login;
            $ar[NME] = str_replace('"', "'", $username );
            $ar['score']++;
            if( $match_title ) {
                $ar['score'] += (($title == $backup_itm[TTL]) ? 1: 0);
            }
            $ar['score'] += ($match_alias && ($citem != null) && ($backup_itm[NME] == $citem[NME]) ? 1: 0);
        }
    }// end author

    elseif( $backup_itm[TYP] == TYPE_LINK || $backup_itm[TYP] == TYPE_SEP || $backup_itm[TYP] == TYPE_ELINK ) {

        // these do not exist in the database
        $ar['in_db'] = -1;
        $ar['score']++; // give this away
        if( $match_title ) {$ar['score']++;}
        $ar['score'] += ($match_alias && ($citem != null) && ($backup_itm[NME] == $citem[NME]) ? 1: 0);
    }

    $ar[OPT] = $opt;
    if( $use_backup_alias ) {
        $ar[NME] = $backup_itm[NME];
    }

    navt_write_debug(NAVT_RESTORE, sprintf("%s (item search ended) returning restore item:\n", __FUNCTION__), $ar);
    return($ar);

}

/**
 * Update the progress bar
 *
 * @param integer $iter
 * @param integer $inc
 * @param integer $pl
 * @param string $plugin_url
 */
function update_progress(&$iter, $inc, &$pl, $plugin_url) {

    $pn = round(++$iter * $inc);

    if($pn != $pl) {
        print '<span class="pbox" style="z-index: ' . $pn . '; top: 265px;">' . $pn . '% </span>';
        $diff = $pn - $pl;
        for($j = 1; $j <= $diff; $j++) {
            print '<img src="' . $plugin_url . '/images/bar-single.gif" width="5" height="15" />';
        }
        $pl = $pn;
    }
}
?>