<?php
/*
Plugin Name: NAVT Word Press Plugin
Plugin URI: http://www.gbellucci.us
Description: Administration Options (form display)
Author: Greg A. Bellucci
Author URI: http://www.gbellucci.us
*/

/**
 * NAVT Word Press Plugin
 * Copyright (c) 2006-2007 Greg A. Bellucci/Atalaya Studio
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software
 * and associated documentation files (the "Software"), to deal in the Software without restriction,
 * including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or substantial
 * portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
 * LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * @package NAVT Word Press Plugin
 * @author Greg A. Bellucci <greg[AT]gbellucci[DOT]us
 * @copyright Copyright &copy; 2006-2007 Greg A. Bellucci
 * @license http://www.opensource.org/licenses/mit-license.php The MIT License
 */
@include('gc/gc.php');

/**
 * @global object $wpdb Word Press Database Class
 * @global string $table_prefix
 */

// directory permission checking



$spinner = NAVT::get_url() .'/'. IMG_SPINNER;
global $grp_array, $default_avatar;


$in = 3;
$controls = "";

// load the navigation items and groups
$map_array = NAVT::load_map();
$grp_array = NAVT::get_groups($map_array);


/* @since 95.37 */
$curdflt = NAVT::get_option(DEF_ADD_GROUP);
if( empty($curdflt) ||  '' == $curdflt ) {
    $curdflt = ID_DEFAULT_GROUP;
    NAVT::update_option(DEF_ADD_GROUP, $curdflt); // for upgrades to 95.37
}

$ddlist = sprintf("<select id=\"navt_default_group\" name=\"navt_default_group\">\n");
$curdflt = isBlank($curdflt) ? $grp_array[0]: $curdflt;
for( $i = 0; $i < count($grp_array); $i++ ) {
    $select = (($curdflt == $grp_array[$i]) ? 'selected="selected"': '');
    $ddlist .= sprintf("<option value=\"%s\"%s>%s</option>\n", $grp_array[$i], $select, strtolower($grp_array[$i]));
}
$ddlist .= sprintf("</select>\n");
$ddlist .= sprintf("<input type='hidden' id='default_group_selection' value='%s' />", $curdflt);

// Create a navigation division template - this template is hidden in the form and it used
// to create new navigation groups via node cloning.
//
$style = sprintf("style=\"%s\"", STY_HIDDEN);
$controls .= NAVT_startGroup(ID_GROUP_TEMPLATE, '', CLS_MENUGROUP, $style, true, 0, $in);
$controls .= NAVT_endGroup(ID_GROUP_TEMPLATE, 0, $in);

if(is_array($grp_array) && count($grp_array) > 0) {
    for( $i = 0; $i < count($grp_array); $i++ ) {
        // create a navigation group division
        $classCss = ($grp_array[$i] == ID_DEFAULT_GROUP) ? CLS_STATIONARY_GROUP: CLS_MENUGROUP;
        $hasMenu = !($grp_array[$i] == ID_DEFAULT_GROUP);
        $scheme  = ($grp_array[$i] == ID_DEFAULT_GROUP) ? '': NAVT_getNextScheme($i);
        $grp_options = NAVT_set_group_options($grp_array[$i], $map_array);
        $controls .= NAVT_startGroup($grp_array[$i], $scheme, $classCss, '', $hasMenu, $grp_options, $in);
        $seq = 1;

        foreach($map_array as $itm) {
            // add the item if it belongs to this group
            if( $itm[GRP] == $grp_array[$i] ) {
                $has_items++;
                $itm[OPT] = NAVT_cleanOptions(intval($itm[OPT])); // clean the item options
                $controls .= NAVT_addMenuResource($seq++, $itm, $in+2, 0);
            }
        }
        // end the section division
        $controls .= NAVT_endGroup($grp_array[$i], $grp_options, $in);
    }// end for
    $controls .= sprintf("%s<input id=\"%s\" type=\"hidden\" value=\"%s\" />\n", _indentt($in), ID_SCHEME, count($grp_array));
}// end if

/**
 =======================
 * Form Begins
 =======================
 */ ?>
<?php print "\n";?>
<div id="NAVT_form" class="wrap" >

   <h2>Navigation Management  <span id="new_version" style="font-size: .35em;"></span></h2>
   <?php
   if( !function_exists('xml_parser_create') ) {
       $exlink = "http://www.php.net/manual/en/ref.xml.php";
       $msg .= sprintf("<h3>".__('Opps, Missing Components')."</h3><p>".__('Your PHP installation is missing the
       <a rel=\"nofollow\" href=\"%s\">Expat XML parser functions</a> that are required by this plugin.')."<br />\n", $exlink);
       $msg .= sprintf(__("These functions are typically enabled by default. However, they don't appear to be included in your installation.<br />Contact your server hosting service to have your PHP installation checked.</p>"));
       echo $msg . '<small>'. _e(SCRIPTNAME) . ' v' . _e(SCRIPTVERS) . '</small>';
   }
    else { ?>

   <?php /* <form id="navt_configure" onSubmit="" method="post" enctype="multipart/form-data">
      <?php wp_original_referer_field();*/ ?>

      <?php /* Create new group */ ?>

      <div class="dbx-group" id="pluginsidebar">
         <fieldset class="dbx-box">
            <h3 class="dbx-handle"><?php _e('Group Edit');?></h3>
            <div class="dbx-content">
                <h4 class="subtitle"><?php _e('Add Navigation Group');?></h4>
                <p><small><?php _e('Enter a group name (A group name must begin with a letter and may be followed by any number of letters or numbers; A name may not contain spaces or underscores)')?></small></p>
                <p><label><?php _e('Group Name:');?></label><br />
                <input type="text" id="<?php echo ID_SYSTEXTBOX;?>" maxsize="<?php echo MAX_GROUP_NAME;?>" size="15" /></p>
                <p class="submit"><input type="button" id="NAVT_addgroup" class="<?php echo CLS_ADD_GROUP;?>" value='<?php _e("New &raquo;");?>'/></p>
                <p id="syserr" class="error" style="display:none"></p>
            </div>
         </fieldset>
        <br />

        <?php /* Form changes */ ?>

         <fieldset class="dbx-box">
            <h3 class="dbx-handle"><?php _e('Form Changes');?></h3>
            <div class="dbx-content">
                <h4 class="subtitle"><?php _e('Update Group Changes.');?></h4>
                <p><small><?php _e('<span style="text-decoration: underline;">Click Save only once</span>, this takes a few moments to begin if you have a large number of items.');?></small></p>
                <p class="submit"><img id="navt_spinner" class="spin" src="<?php echo $spinner;?>" alt=<?php _e("Please wait...");?> style="display:none;" />
                <input type="button" id="NAVT_update" name="NAVT_update" value=<?php _e("Save &raquo;");?>  class="apply button ok" /></p>
                <?php $next_update = 0;
                if( isset($_POST['restore_status']) ) { $next_update++; $td = ' - ' . date(get_option('date_format')) . ', ' . date(get_option('time_format'));?>
                <p id="pm1" class="last_updated"><?php echo $_POST['restore_status'] . $td;?></p><?php } else { ?><p id="pm1"></p><?php } ?>
                <p id="pm2"></p><p id="pm3"></p><p id="pm4"></p><p id="pm5"></p>
                <input type="hidden" id="nxtupdate" value="<?php echo $next_update;?>" />
            </div>
         </fieldset>
         <br />

         <?php /*  Default group for category creation */?>

         <?php
         if( !isBlank($ddlist) ) { ?>
         <fieldset class="dbx-box">
            <h3 class="dbx-handle"><?php _e('Options');?></h3>
            <div class="dbx-content">
                <p><small><?php _e('Categories created at the time of a post are to be added to the navigation group below.');?></small></p>
                <h4 class="subtitle"><?php _e('Navigation Group:');?></h4>
                <?php echo $ddlist; ?>
            </div>
         </fieldset>
         <?php } ?>
         <?php if( function_exists('navt_gc_sidebar') ) { navt_gc_sidebar(); } ?>
         <br />

         <?php /* Backup/ Restore @since .95.42 */ ?>

         <fieldset class="dbx-box">
            <h3 class="dbx-handle"><?php _e('Backup/Restore');?></h3>
            <div class="dbx-content">
                <h4 class="subtitle"><?php _e('Backup Navigation Groups');?></h4>
                <form id="navt_backup_restore" onSubmit="" method="post" enctype="multipart/form-data">
                    <p><small><?php _e('When you click the button below NAVT will create an XML file for you to save to your computer.');?></small></p>
                    <p class="submit"><input type="submit" id="NAVT_backup_plugin" name="NAVT_backup_plugin" value="Create Backup &raquo;" class="button "></p>
                </form>
                <hr />
                <h4 class="subtitle"><?php _e('Restore From Backup');?></h4>
                <form id="navt_backup_restore" onSubmit="" method="post" enctype="multipart/form-data">
                    <p class="submit"><input type="submit" id="NAVT_restore_plugin" name="NAVT_restore_plugin" value="Restore &raquo;" class="button delete"></p>
                </form>
            </div>
         </fieldset>
         <br />

         <?php /* Forum/Version checking */

         $vercheck = intval(NAVT::get_option(VERCHECK));
         $tips = intval(NAVT::get_option(TIPS));
         $nm =  SCRIPTNAME;
         $ver = SCRIPTVERS;
         $version_checking_enabled = (($vercheck === 1) ? 'checked="checked"':'');
         $tips_enabled = (($tips === 1) ? 'checked="checked"':'');
               ?>
         <fieldset class="dbx-box">
            <h3 class="dbx-handle"><?php _e('Plugin Info');?></h3>
            <div class="dbx-content">
                <p><?php echo $nm . ' v'.$ver;?></p>
                <p><a href="<?php echo _e(PLUGIN_FORUM);?>" target="_blank" title=<?php _e("Official NAVT Plugin Forum");?>><?php _e('Plugin Forum');?></a>
                <small><em><?php _e('(Opens new window)');?></em></small></p>
                <?php /* Version checking is automatically provided by wp 2.3 @since 95.42 */ global $wp_db_version; //  6124 = wp 2.3
                if( $wp_db_version < 6124 ) { ?><p><input type="checkbox" id="NAVT_vercheck" name="NAVT_vercheck" value="1" <?php echo $version_checking_enabled;?>/><small> <?php _e('Automatically check for updates');?></small></p><?php if($vercheck) { echo VERSION_CHECK; }} ?>
                <p><input type="checkbox" id="NAVT_tips" name="NAVT_tips" value="1" <?php echo $tips_enabled;?>/><small> <?php _e('Turn On Help Tips');?></small></p>
            </div>
         </fieldset>
      </div>

      <?php /* View filter for unassigned group */ ?>

      <div id="NAVT-container" class="NAVT-block">
         <div id="navt_filter">
            <h3><?php _e('Item Filter');?></h3>
            <select id="<?php echo ID_VUSELECT;?>">
                <option value="<?php echo VALL;?>"><?php _e('View All');?></option>
                <option value="<?php echo VPAGES;?>"><?php _e('View Pages');?></option>
                <option value="<?php echo VPAGES_CATS;?>"><?php _e('View Pages/Categories');?></option>
                <option value="<?php echo VCATS;?>"><?php _e('View Categories');?></option>
                <option value="<?php echo VUSERS;?>"><?php _e('View Users');?></option>
                <option value="<?php echo VLINKS;?>"><?php _e('View Links');?></option>
                <option value="<?php echo HITEMS;?>"><?php _e('Show Unused Items');?></option>
            </select>
         </div>

         <?php /*  navigation groups and items */ ?>

         <div id="<?php print ID_PAGE_WRAPPER;?>">
             <?php print $controls;?>
         </div>

         <div class="clear"></div>
      </div>
   </form><!--/form-->

   <form id="navt_reset" onSubmit="" method="post" enctype="multipart/form-data">
       <fieldset class="pluginreset">
           <h3><?php _e("Plugin Reset");?></h3>
           <p><?php _e("This plugin stores information regarding group configurations in the options table of the database. Clicking the button below will remove the plugin's option information from the database and replace them with the plugin's default values. The reset button can be used when you'd like to create new navigation groups using a <em>clean</em> installation.");?></p>
           <p><input type="submit" id="NAVT_uninstall_plugin" name="NAVT_uninstall_plugin" value=<?php _e("Reset to Defaults &raquo;)");?>  class="button delete"></p>
       </fieldset>
  <?php /* </form> */ ?>
<?php } /* end else */ ?>
</div><!--/.wrap-->

<?php

/**
 * Helper functions
 */

/**
 * Determine the group options (if any)
 *
 * @param string $name - name of the navigation group
 * @package array - the map array
 * @return  - returns an integer with the bit setting for this group's options
 * @since .95.2
 */
function NAVT_set_group_options($name, $map) {

    $ret = 0; // none

    // Group options
    //   group may be displayed as a dropdown menu
    foreach($map as $itm) {
        $iopt = intval($itm[OPT]);
        if( ($itm[GRP] == $name) && ($iopt & HAS_DD_OPTION) ) {
            $ret |= HAS_DD_OPTION; // set this bit
        }
        if( ($itm[GRP] == $name) && ($iopt & HAS_NOSTYLE) ) {
            $ret |= HAS_NOSTYLE; // set this bit
        }
    }
    return($ret);
}

/**
 * Remove group option bits from a item option
 *
 * @param integer $opt
 * @return integer
 */
function NAVT_cleanOptions($opt) {
    if( $opt & HAS_DD_OPTION ) {$opt -= HAS_DD_OPTION;}
    if( $opt & HAS_NOSTYLE ) { $opt -= HAS_NOSTYLE; }
    return($opt);
}


/**
 * Create the start of a navigation group
 *
 * @param string $name - name of the navigation group
 * @param string $divcls - division class
 * @param integer $in - starting indentation value (HTML format)
 * @return string $html HTML output text
 *
 */
function NAVT_startGroup($name, $scheme, $classCss, $style, $hasMenu, $grp_options, $in) {

    $gClassCss = sprintf("class=\"%s %s\"", $classCss, (!isBlank($scheme)) ? $scheme: '');
    $html = '';
    $handle = CLS_MENUGROUP_HANDLE;
    $handle .= ($name != ID_DEFAULT_GROUP) ? '' : DELIM;
    $hdrName = ($name != ID_GROUP_TEMPLATE) ? $name: '';

    $html .= sprintf("\n%s<%s %s id=\"%s\" %s>\n", _indentt($in), CLS_GSORT_TAG, $gClassCss, $name, $style);
    $html .= sprintf("%s<h3 class=\"%s\" id=\"%s\">%s</h3>\n", _indentt($in+1), $handle, $name.ID_SFX_GROUPNAME, strtolower($hdrName));

    if( $hasMenu ) {
        // group navigation and rename navigation group controls
        $html .= NAVT_addGroupMenu($name, $grp_options, $in+1);
        $html .= NAVT_addGroupControls($name, $in+1);
    }

    // Start wrapper for navigation items that are part of this group
    $zclass = CLS_FDIV;
    $zclass .= ($name != ID_GROUP_TEMPLATE) ? ' '.CLS_DROPZONE: '';
    $html .= sprintf("%s<ul class=\"%s\" id=\"%s\">\n",  _indentt($in+1), $zclass, $name.ID_SFX_FDIV);
    $html .= sprintf("%s<li class=\"ph\">&nbsp;</li>\n", _indentt($in+2)); //a blank space

    if( $name != ID_DEFAULT_GROUP ) {
        /**
        * @since .95.1
        * Blank Divider Element (template)
        */
        $args = array('grp' => $name, 'typ' => TYPE_SEP,
        'idn' => 0,    'ttl' => DEF_SEPTEXT, 'nme' => DEF_SEPTEXT,
        'opt' => '0',  'ext' => '', 'lvl' => '0',  'ex2' => '');
        $itm = navt_format_menu_item($args);
        $html .= NAVT_addMenuResource($name, $itm, $in+2, 1);

        /**
        * @since .95.1
        * External Link Element(template)
        */
        $args = array('grp' => $name, 'typ' => TYPE_ELINK,
        'idn' => 0,    'ttl' => 'http://', 'nme' => DEF_ELINKTEXT,
        'opt' => '0',  'ext' => '', 'lvl' => '0',  'ex2' => '');
        $itm = navt_format_menu_item($args);
        $html .= NAVT_addMenuResource($name, $itm, $in+2, 1);
    }
    return($html);
}

/**
 * Completes the HTML output for a navigation group
 *
 * @param integer $in - starting indentation value (HTML format)
 * @param integer $grp_options - options for this group
 * @return string $html HTML output text
 */
function NAVT_endGroup($name, $grp_options, $in) {

    // end of navigation items wrapper and end of navigation group
    $html = '';
    $html .= sprintf("%s</ul><!--/%s-->\n", _indentt($in+2), CLS_FDIV);
    $html .= sprintf("%s<input id=\"%s\" type=\"hidden\" value=\"%s\" />\n", _indentt($in+2), $name.ID_SFX_GROUPOPT, $grp_options); //@since .95.2
    $html .= sprintf("%s</%s><!--/%s-->\n", _indentt($in+1), CLS_GSORT_TAG, CLS_MENUGROUP);

    return($html);
}

/**
 * Creates a menu for a navigation group
 *
 * @param integer $in - starting indentation value (HTML format)
 * @return string $html HTML output text
 *
 * @since 95.42 - added onclicks
 */
function NAVT_addGroupMenu($name, $grp_options, $in) {

    $img = NAVT::get_url() . '/' . IMG_BLANK;
    $gopt = intval($grp_options);
    $dd_option = sprintf("%s%s", ($gopt & HAS_DD_OPTION) ? '&radic; ':'', GM_DROPDOWN_FORMAT);
    $st_option = sprintf("%s%s", ($gopt & HAS_NOSTYLE) ? '&radic; ':'', GM_NOSTYLE);
    $fold = sprintf("<span id='%s_folder' class='foldicon close' onClick=\"return(toggle_folder(this));\"><a href='#'><img src='%s' alt='' /></a></span>", $name, $img);
    $html .= sprintf("%s<div id='%s_gmu-a' class='group-menu'><h4 class='gmenubutton'><a id='%s_gmu-b' href='#' onclick='return(grp_menu(this, \"%s\"))'>".__("Group Options")."</a></h4>%s\n", _indentt($in), $name, $name, "open", $fold);

    $sfmt = "%s<li class='".KW_CLS."%s ". CLS_GRPMENUITEM . "' id='".$name."%s' onclick=\"return(grp_menu(this, '%s'));\"><a href='#'>%s</a></li>\n";
    $html .= sprintf("%s<ul id='%s_list' class='mlist' style='display:none;'>\n", _indentt($in+1), $name);
    $html .= sprintf($sfmt, _indentt($in+2), ID_SFX_RENAME,     ID_SFX_RENAME,     __("rename"),     GM_RENAME);      // rename
    $html .= sprintf($sfmt, _indentt($in+2), ID_SFX_DELETE,     ID_SFX_DELETE,     __("delete"),     GM_DELETE);      // delete
    $html .= sprintf($sfmt, _indentt($in+2), ID_SFX_EXTLINK,    ID_SFX_EXTLINK,    __("addlink"),    GM_ADD_LINK);    // add external link
    $html .= sprintf($sfmt, _indentt($in+2), ID_SFX_SEP,        ID_SFX_SEP,        __("adddiv"),     GM_ADD_DIVIDER); // add divider
    $html .= sprintf($sfmt, _indentt($in+2), ID_SFX_DD,         ID_SFX_DD,         __("dropdown"),   $dd_option);     // dropdown format
    $html .= sprintf($sfmt, _indentt($in+2), ID_SFX_NC,         ID_SFX_NC,         __("nostyle"),    $st_option);     // noclass format
    $html .= sprintf($sfmt, _indentt($in+2), ID_SFX_OPNALL,     ID_SFX_OPNALL,     __("openall"),    GM_OPEN_ALL);    // expand all items
    $html .= sprintf($sfmt, _indentt($in+2), ID_SFX_CLOALL,     ID_SFX_CLOALL,     __("closeall"),   GM_CLOSE_ALL);   // collapse all items
    $html .= sprintf($sfmt, _indentt($in+2), ID_SFX_RESTOREALL, ID_SFX_RESTOREALL, __("restoreall"), GM_RESTORE_ALL); // Restore hidden items

    //$html .= sprintf($sfmt, ID_SFX_GENGCSS, ID_SFX_GENGCSS, GM_GENG_CSS);  // generate group css
    $html .= sprintf("%s</ul>\n", _indentt($in+1));
    $html .= sprintf("%s</div>\n", _indentt($in));

    return($html);
}

/**
 * Creates the navigation group rename controls
 *
 * @param string $name - name of the menu group
 * @param integer $in - starting indentation value (HTML format)
 * @return string $html HTML output text
 *
 */
function NAVT_addGroupControls($name, $in) {
    $img = NAVT::get_url() . '/' . IMG_BLANK;
    $sfmt = "<a class=\"%s\" href=\"#\" onclick=\"return(%s);\"><img src=\"" . $img . "\" alt=\"%s\" title=\"%s\"/></a>";

    $ok  = sprintf($sfmt, CLS_MLINK_OK,  "grp_click(this, 'rename', 'ok')", 'Ok', OK_TEXT);
    $can = sprintf($sfmt, CLS_MLINK_CAN, "grp_click(this, 'rename', 'cancel')", 'Cancel', CANCEL_TEXT);

    $html = '';
    // Rename group
    $html .= sprintf("%s<div class=\"%s\" id=\"%s\" style=\"%s\">\n", _indentt($in), CLS_MMENU, $name.ID_SFX_MMENU, STY_HIDDEN);
    $html .= sprintf("%s<fieldset><legend>".__("Rename Navigation Group")."</legend>\n", _indentt($in+1));
    $html .= sprintf("%s<input id=\"%s\" type=\"text\" size=\"%s\" maxlength=\"%s\" value=\"%s\"/><br clear=\"all\" />\n",
    _indentt($in+2), $name.ID_SFX_TXTBX, MAX_GROUP_NAME, MAX_GROUP_NAME, $name);

    $html .= sprintf("%s<div class=\"okcan\"><p id=\"%s\">%s</p>\n", _indentt($in+2), $name.ID_SFX_OK . '-1', $ok);
    $html .= sprintf("%s<p id=\"%s\">%s</p></div>\n", _indentt($in+3), $name.ID_SFX_CANCEL . '-1', $can);
    $html .= sprintf("%s<p class=\"%s\" id=\"%s\" style=\"%s\"></p>\n", _indentt($in+3), CLS_MSG, $name.MSG_SFX, STY_HIDDEN);
    $html .= sprintf("%s</fieldset>\n", _indentt($in+2));
    $html .= sprintf("%s</div>\n", _indentt($in+1));

    $ok  = sprintf($sfmt, CLS_MDELE_OK,  "grp_click(this, 'delete', 'ok')",      'Ok', OK_TEXT);
    $can = sprintf($sfmt, CLS_MDELE_CAN, "grp_click(this, 'delete', 'cancel')",  'Cancel', CANCEL_TEXT);

    // Delete confirmation
    $html .= sprintf("%s<div class=\"%s\" id=\"%s\" style=\"%s\">\n", _indentt($in+1), CLS_MDELE, $name.ID_SFX_MDELE, STY_HIDDEN);
    $html .= sprintf("%s<h4>".__("Confirm Group Delete")."</h4>\n", _indentt($in+2));
    $html .= sprintf("%s<div class=\"okcan\"><p id=\"%s\">%s</p>\n", _indentt($in+2), $name.ID_SFX_OK . '-2', $ok);
    $html .= sprintf("%s<p id=\"%s\">%s</p></div>\n", _indentt($in+2), $name.ID_SFX_CANCEL . '-2', $can);
    $html .= sprintf("%s</div>\n", _indentt($in+1));

    return($html);
}

/**
 * Format a single navigation resource entry for the display
 *
 * @param integer $seq - a sequence number
 * @param array $itm - the menu item
 * @param integer $in - starting indentation value (HTML format)
 * @param integer $templateFormat - true if the item should be in template format
 * @return string $html HTML output text
 *
 * @since 95.42 - added onclicks
 */
function NAVT_addMenuResource($seq, $itm, $in, $templateFormat) {

    global $navt_domain;

    $help = NAVT::get_url() . '/'. IMG_BLANK;
    $id = NAVT_make_item_id($itm[TYP], $itm[IDN], $itm[GRP]);
    $opt_title = NAVT::truncate($itm[NME], 15);
    if(!is_numeric($itm[LVL])) $itm[LVL] = fix_level($itm);
    if(!is_numeric($itm[OPT])) $itm[OPT] = '0';

    // remove the dropdown option if its there
    $opt = intval($itm[OPT]);
    $addcss .= (($opt & ISPRIVATE) ? ' ' . CLS_PRIVATE: '')  . NAVT_set_level($itm);

    switch( $itm[TYP]) {

        case TYPE_CAT:
            $img_class = CLS_CAT_ICON;
            $append_ck_state = ( ($opt & NO_LINK_TEXT) ? 0: ( ($opt & APPEND_POST_COUNT) ? 1: 0 ) );
            $append_text = sprintf("<span id='%s_lbl'%s>%s</span>", $id.ID_SFX_CB2,
            (($opt & NO_LINK_TEXT) ? " class='disabled'":''), __("Append post count"), $navt_domain);
            $options = sprintf("%s<div class=\"catopts\">\n", _indentt($in+3));
            $options .= cbox( $id.ID_SFX_CB1, '', $opt & SHOW_IN_LIST, 0, __("Show in WP category list"), $in+4);
            $options .= cbox( $id.ID_SFX_CB2, '', $append_ck_state, $opt & NO_LINK_TEXT, $append_text, $in+4);
            $options .= cbox( $id.ID_SFX_CB3, '', $opt & SHOW_IF_EMPTY, 0, __("Show if empty"), $in+4);
            $options .= cbox( $id.ID_SFX_CB4, '', $opt & USE_CAT_DESC, 0, __("Use description as tooltip"), $in+4);
            $options .= NAVT_add_common_options($id, $opt, $itm, $in+4, ID_SFX_ANCHOR_OPTS);
            //$options .= cbox( $id.ID_SFX_CB5, '', $opt & ISPRIVATE, 0, "Private (Must login to see))", $in+4);
            $options .= sprintf("%s</div>\n", _indentt($in+3));

            // make this item
            $html = NAVT_make_item("Name:", $img_class, $options, $seq, $itm, $in);
            break;

        case TYPE_PAGE:
            $img_class = CLS_PAGE_ICON;
            $options .= NAVT_add_common_options($id, $opt, $itm, $in+4, ID_SFX_ANCHOR_OPTS);

            // make this item
            $html .= NAVT_make_item("Name:", $img_class, $options, $seq, $itm, $in);
            break;

        case TYPE_SEP:

            $nme = $itm[NME];
            $ttl = $itm[TTL];

            $tip = sprintf("<div class='helpdiv'><a href='%s' class='navt-jTip helptip' title='' id='bt-%s'><img class='helpicon' src='%s' /></a></div>",
            NAVT::get_url() .'/app/navtip.php?tipid='.$itm[TYP].'&width='.HELP_WIDTH, $id, $help);
            $img_class = CLS_DIVID_ICON . $addcss;
            $img = sprintf("%s", NAVT::get_URL().'/'.IMG_BLANK);
            $tclass = ($templateFormat) ? CLS_ITMPL: CLS_PGCT;
            $tclass = $tclass . ' '. CLS_RDRAG . $addcss;  // @since 95.30
            $style = sprintf("style='position:relative;%s'", ($templateFormat) ? 'display:none;':'');

            $html .= sprintf("%s<%s class=\"%s %s\" id=\"%s\" %s>%s\n", _indentt($in), CLS_MSORT_TAG, $tclass, CLS_SEP, $id.ID_SFX_MENUITEM,
            $style, NAVT_add_hierarchy_controls($id));
            $html .= sprintf("%s<img id=\"%s\" class=\"%s %s\" src=\"%s\"/>\n", _indentt($in+1), $id.ID_SFX_IKON, CLS_MENUITEM_HANDLE, $img_class, $img);
            $html .= sprintf("%s<h4><a class=\"%s\" id=\"%s\" href=\"#\" onclick=\"return(item_click(this, 'open'));\" title=\"%s\">%s</a></h4>\n",
            _indentt($in+1), CLS_OPTBOX, $id.ID_SFX_OPTBOX, $nme, $opt_title);
            $html .= sprintf("%s<div class=\"%s\" id=\"%s\" style=\"%s\">\n", _indentt($in+1), CLS_IMENU, $id.ID_SFX_IMENU, STY_HIDDEN);

            // Options menu
            $state = ($opt & PLAIN_TEXT_OPTION) ? '' : 'disabled="disabled"';
            $iclass = ($opt & PLAIN_TEXT_OPTION) ? '' : 'class="disabled"';
            $html .= sprintf("%s<fieldset><legend>Text (plain text option):</legend> %s\n",_indentt($in+2), $tip);
            $html .= sprintf("%s<input %s type=\"text\" id=\"%s\" size=\"%s\" maxlength=\"%s\" value=\"%s\"%s/><br clear=\"all\" />\n",
            _indentt($in+3), $iclass, $id.ID_SFX_TXTBX, MAX_ALIAS_NAME, MAX_LEN, $nme, $state );

            //dropdown box
            $html .= sprintf("%s<label>Divider Type:</label>\n",_indentt(($in+3)));
            $html .= sprintf("%s<select class=\"selbox divider_selection\" id=\"%s\" >\n", _indentt($in+3), $id.ID_SFX_DD);

            $sfmt = _indentt($in+4) . "<option %s value=\"%s\">%s</option>\n";
            $html .= sprintf($sfmt, ((($opt & EMPTY_SPACE_OPTION) == 0) ? 'selected="selected"': ''), EMPTY_SPACE_OPTION, OPT_EMPTYTEXT); // option 1
            $html .= sprintf($sfmt, (($opt & HRULE_OPTION) ? 'selected="selected"':'') , HRULE_OPTION, OPT_HRULE); // option 2
            $html .= sprintf($sfmt, (($opt & PLAIN_TEXT_OPTION) ? 'selected="selected"':''), PLAIN_TEXT_OPTION, OPT_PTEXT); // option 3
            $html .= sprintf("%s</select><br />\n", _indentt($in+3));

            $options .= cbox( $id.ID_SFX_CB5, '', $opt & ISPRIVATE, 0, "Private (Must login to see)", $in+3);

            // Delete, Ok and Cancel buttons
            $html .= NAVT_make_ok_can_del($id, $in+3);
            $html .= sprintf("%s</fieldset>\n", _indentt($in+2));

            // form storage
            $html .= NAVT_add_storage_items($id, $itm, $in+2); /** @since 95.38 */
            $html .= sprintf("%s</div>\n", _indentt($in+1));
            $html .= sprintf("%s</%s>\n", _indentt($in), CLS_MSORT_TAG);
            break;

        case TYPE_LINK:
            $idn = intval($itm[idn]);
            $img_class = ( ($idn == HOMEIDN) ? CLS_HOME_ICON : (($idn == LOGINIDN) ? CLS_ADMIN_ICON : CLS_LINK_ICON) );
            $options .= NAVT_add_common_options($id, $opt, $itm, $in+3, ID_SFX_ANCHOR_OPTS);

            if( LOGINIDN == $itm[IDN] ) {
                $options .= cbox( $id.ID_SFX_CB1, '', ($opt & USE_FORM), 0, "Create Login Form", $in+3);
                $lb = sprintf("<span id='%s_lbl'> Use Referral Page Redirect </span>", $id.ID_SFX_CB2);
                $options .= cbox( $id.ID_SFX_CB2, 'sub', ($opt & REDIRECT_REFER), !($opt & USE_FORM), $lb, $in+3);
                $lb = sprintf("<span id='%s_lbl'> Use URL Redirect </span>", $id.ID_SFX_CB3);
                $options .= cbox( $id.ID_SFX_CB3, 'sub', ($opt & REDIRECT_URL), !($opt & USE_FORM) , $lb, $in+3);
                $options .= sprintf("%s<label id='%s_lbl'>URL Redirect:</label>\n",_indentt($in+3), $id.ID_SFX_REDIRECT);
                $options .= sprintf("%s<input type='text' id='%s' size='%s' maxlength='%s' value='%s' %s/><br />\n",
                _indentt($in+3), $id.ID_SFX_REDIRECT, MAX_ALIAS_NAME, MAX_LEN, $itm[EX2], ($opt & REDIRECT_URL) ? '' : 'disabled=disabled');
            }
            // make this item
            $html = NAVT_make_item("Name:", $img_class, $options, $seq, $itm, $in);
            break;

        case TYPE_AUTHOR:
            global $navt_domain;
            $img_class = CLS_AUTHOR_ICON;

            $options = sprintf("%s<div class=\"authopts\">\n", _indentt($in+3));
            $options .= sprintf("%s<fieldset>\n",_indentt(($in+4)));

            // set default conditions
            $enable_avatar_dropdown = $enable_no_link_text = 1;
            $enable_user_avatar_url = 0;
            $avatar_url = $itm[EXT];
            $show_avatar = ($opt & SHOW_AVATAR) ? 1: 0;

            if(!$show_avatar) {
                $enable_avatar_dropdown = $enable_no_link_text = 0;
            }
            else {
                // displaying avatar
                if(!($opt & USE_DEF_AVATAR)) {
                    // but not default
                    $enable_avatar_dropdown = 0;
                    $enable_user_avatar_url = 1;
                }
            }

            $user_avatar_url_label_class = ($enable_user_avatar_url) ? '' : CLS_DISABLED;
            $no_link_text_class = ($enable_no_link_text) ? '' : CLS_DISABLED;

            // Option to display an avatar
            $options .= cbox( $id.ID_SFX_CB1, 'showavatar', $show_avatar, 0, "Show avatar", $in+5, 0);
            $options .= sprintf("%s<img id=\"%s\" class=\"imgleft avatar\" src=\"%s\" /><br />\n", _indentt($in+5), $id.ID_SFX_AVATAR_IMG, $avatar_url);

            // Option to use the default avatar
            $lclass = $show_avatar ? '' : 'class="disabled"';
            $cclass = sprintf("usedefavatar%s", $show_avatar ? '' : ' disabled');
            $label = sprintf("<span id='%s_lbl' %s> %s</span>", $id.ID_SFX_CB4, $lclass, __("Use default", $navt_domain));
            $options .= cbox($id.ID_SFX_CB4, $cclass, ($opt & USE_DEF_AVATAR), !$show_avatar, $label, $in+5);

            // add avatar selections
            $options .= NAVT::build_avatar_list(0, !$enable_avatar_dropdown, $id.ID_SFX_AVATAR_LIST, $avatar_url, $in+5);

            // avatar input textbox
            $options .= sprintf("%s<br /><label id=\"%s_lbl\" %s>Avatar URI:</label>\n",_indentt(($in+5)), $id.ID_SFX_ATXTBX, $user_avatar_url_label_class);
            $options .= sprintf("%s<input type=\"text\" id=\"%s\" size=\"%s\" maxlength=\"%s\" value=\"%s\" %s %s/>\n",
            _indentt($in+5), $id.ID_SFX_ATXTBX, 28, MAX_LEN, $avatar_url, ('' != $user_avatar_url_label_class ? 'class="'.$user_avatar_url_label_class.'"':''),
            ((!$enable_user_avatar_url) ? 'disabled="disabled"': ''));

            $options .= sprintf("%s</fieldset>\n",_indentt(($in+4)));

            // Option to append the post count to the Authors link (bit 2)
            $options .= cbox($id.ID_SFX_CB2, '', $opt & APPEND_POST_COUNT, $opt & NO_LINK_TEXT,
            sprintf("<span id='%s_lbl' %s>%s</span>", $id.ID_SFX_CB2, ($opt & NO_LINK_TEXT ? 'class="'.CLS_DISABLED.'"' : ''), " Append post count"), $in+5);

            // Add user options
            $options .= cbox( $id.ID_SFX_CB3, '', $opt & SHOW_IF_EMPTY, 0, "Show if no posts", $in+5);
            $lb = sprintf("<span id='%s_lbl'> Include email address </span>", $id.ID_SFX_CB11);
            $options .= cbox( $id.ID_SFX_CB11, '', $opt & INC_EMAIL, ($opt & NO_LINK_TEXT), $lb, $in+5);
            $lb = sprintf("<span id='%s_lbl'> Include website address </span>", $id.ID_SFX_CB7);
            $options .= cbox( $id.ID_SFX_CB7, '', $opt & INC_WEBSITE, ($opt & NO_LINK_TEXT) , $lb, $in+5);
            $lb = sprintf("<span id='%s_lbl'> Include bio summary </span>", $id.ID_SFX_CB9);
            $options .= cbox( $id.ID_SFX_CB9, '', $opt & INC_BIO, ($opt & NO_LINK_TEXT), $lb, $in+5);
            $options .= sprintf("%s</div>\n", _indentt($in+4));

            // Option for hiding link text @since 95.38
            $label = sprintf("<span id=\"%s_lbl\" %s>%s</span>", $id.ID_SFX_CB8, ('' != $no_link_text_class ? 'class="'.$no_link_text_class.'"':''),
            __( " Hide link text", $navt_domain));
            $options .= cbox( $id.ID_SFX_CB8, ' hidelink', ($opt & NO_LINK_TEXT), !$enable_no_link_text, $label, $in+3);

            // make this item
            $html = NAVT_make_item("User Display Name:<br />", $img_class, $options, $seq, $itm, $in);
            break;

        case TYPE_ELINK:

            $nme = $itm[NME];
            $ttl = $itm[TTL];

            $img_class = CLS_ELINK_ICON;
            $img = sprintf("%s", NAVT::get_URL().'/'.IMG_BLANK);
            $tclass = ($templateFormat) ? CLS_ITMPL: CLS_PGCT;
            $tclass = $tclass . ' '. CLS_DRAG . ' ' . CLS_ELINK . $addcss;  /** @since 95.30 **/
            $tclass .= ($opt & DO_NOT_DISPLAY) ? ' ' . CLS_NOSHOW: ''; /** @since 95.38 **/
            $style = sprintf("style='position:relative;%s'", ($templateFormat || ($opt & DO_NOT_DISPLAY)) ? 'display:none;':'');
            $tip = sprintf("<div class='helpdiv'><a href='%s' class='navt-jTip helptip' title='' id='bt-%s'><img class='helpicon' src='%s' /></a></div>",
            NAVT::get_url() .'/app/navtip.php?tipid='.$itm[TYP].'&width='.HELP_WIDTH, $id, $help);

            $html .= sprintf("%s<%s class=\"%s\" id=\"%s\" %s>%s\n", _indentt($in), CLS_MSORT_TAG, $tclass, $id.ID_SFX_MENUITEM, $style,
            NAVT_add_hierarchy_controls($id));
            $html .= sprintf("%s<img id=\"%s\" class=\"%s %s\" src=\"%s\"/>\n", _indentt($in+1), $id.ID_SFX_IKON, CLS_MENUITEM_HANDLE, $img_class, $img);
            $html .= sprintf("%s<h4><a class=\"%s\" id=\"%s\" href=\"#\" onclick=\"return(item_click(this, 'open'));\" title=\"%s\">%s</a></h4>\n",
            _indentt($in+1), CLS_OPTBOX, $id.ID_SFX_OPTBOX, $nme, $opt_title);
            $html .= sprintf("%s<div class=\"%s\" id=\"%s\" style=\"%s\">\n", _indentt($in+1), CLS_IMENU, $id.ID_SFX_IMENU, STY_HIDDEN);

            $html .= sprintf("%s<p>Menu Alias</p><input type=\"text\" id=\"%s\" size=\"%s\" maxlength=\"%s\" value=\"%s\"/> %s\n",
            _indentt($in+3), $id.ID_SFX_TXTBX, MAX_ALIAS_NAME, MAX_LEN, $nme, $tip);

            // URL input
            $html .= sprintf("%s<label>URI:</label>\n",_indentt(($in+3)));
            $html .= sprintf("%s<input type=\"text\" id=\"%s\" size=\"%s\" maxlength=\"%s\" value=\"%s\"/>\n",
            _indentt($in+3), $id.ID_SFX_UTXTBX, MAX_ALIAS_NAME, MAX_LEN, $ttl);

            // @since 95.38
            $html .= sprintf("%s<div id=\"%s\">\n", _indentt($in+3), $id.ID_SFX_ADVANCED);
            $html .= sprintf("%s<fieldset class=\"boxit\"><Legend>URI Options:</legend>\n",_indentt(($in+4)));
            $html .= sprintf("%s<select id=\"%s\" class=\"selbox\"><option value=\"0\" %s >Open in NEW window</option><option value=\"%s\" %s>Open in SAME window</option></select><br />\n",_indentt($in+5), $id.ID_SFX_URLWINDOWOPT, (!($opt & OPEN_SAMEWIN) ? 'selected="selected"':''),
            OPEN_SAMEWIN, (($opt & OPEN_SAMEWIN) ? 'selected="selected"':''));

            // url rel=
            $html .= sprintf("%s<select id=\"%s\" class=\"selbox\"><option value=\"0\" %s>rel=NoFollow</option><option value=\"%s\" %s>rel=DoFollow</option></select>\n",_indentt($in+5), $id.ID_SFX_URLFOLLOWOPT, (!($opt & RELFOLLOW) ? 'selected="selected"': ''), RELFOLLOW,(($opt & RELFOLLOW) ? 'selected="selected"': ''));

            $html .= sprintf("%s</fieldset>\n",_indentt(($in+4)));
            $html .= sprintf("%s</div><br />\n", _indentt($in+3));

            $html .= NAVT_add_common_options($id, $opt, $itm, $in+3, ID_SFX_ANCHOR_OPTS);
            $html .= cbox( $id.ID_SFX_CB5, '', $opt & IS_PRIVATE, 0, "Private (Must login to see)", $in+3);
            $html .= NAVT_add_common_options($id, $opt, $itm, $in+3, ID_SFX_CB10);

            // Delete, Ok and Cancel buttons
            //$html .= sprintf("%s<br clear='all' />\n", _indentt($in+3));
            $html .= NAVT_make_ok_can_del($id, $in+3);
            $html .= sprintf("%s</fieldset>\n", _indentt($in+2));

            // form storage
            $html .= NAVT_add_storage_items($id, $itm, $in+2); /** @since 95.38 */
            $html .= sprintf("%s</div>\n", _indentt($in+1));
            $html .= sprintf("%s</%s>\n", _indentt($in), CLS_MSORT_TAG);
            break;

        default:
            $html ='';
            printf("<!-- fell thru - type = %s-->\n", $itm[TYP]);
            break;
    }

    return($html);
}

/**
 * Creates ok, cancel and delete buttons
 *
 * @param string $id
 * @param integer $in
 * @return HTML string
 */
function NAVT_make_ok_can_del($id, $in, $has_ok=1, $has_can=1, $has_del=1) {

    $html = '';
    $img = sprintf("%s", NAVT::get_URL().'/'.IMG_BLANK);
    $sfmt = "<a class=\"%s\" href=\"#\" onclick=\"return(%s);\"><img src=\"" . $img . "\" alt=\"%s\" title=\"%s\" />%s</a>";
    $ok   = sprintf($sfmt, CLS_ILINK_OK,  "item_click(this, 'ok')",  'Ok',     OK_TEXT, '');
    $can  = sprintf($sfmt, CLS_ILINK_CAN, "item_click(this, 'cancel')", 'Cancel', CANCEL_TEXT, '');
    $del  = sprintf($sfmt, CLS_ILINK_DEL, "item_click(this, 'delete')", 'Delete', DELETE_TEXT, '&nbsp;Delete this item');

    if( $has_del ) { $html .= sprintf("%s<p id=\"%s\" class=\"dbutton\">%s</p>\n", _indentt($in), $id.ID_SFX_DELETE, $del); }
    if( $has_ok )  { $html .= sprintf("%s<div class =\"okcan\"><p id=\"%s\">%s</p>\n", _indentt($in), $id.ID_SFX_OK, $ok); }
    if( $has_can ) { $html .= sprintf("%s<p id=\"%s\">%s</p></div>\n", _indentt($in), $id.ID_SFX_CANCEL, $can);}
    $html .= sprintf("%s<p class=\"%s\" id=\"%s\" style=\"%s\"></p>\n", _indentt($in), CLS_MSG, $id.MSG_SFX, STY_HIDDEN);

    return($html);
}


/**
 * Creates a checkbox
 *
 * @param string $id
 * @param string $additional_classes
 * @param boolean $checked_condition
 * @param boolean $disable_condition
 * @param string $label
 * @param integer $indent
 * @param boolean $brafter
 * @return string
 */
function cbox( $id, $add_classes='', $checked_condition=0, $disable_condition=0, $label='no label', $indent=0, $brafter=1) {
    global $navt_domain;
    $checked = (($checked_condition) ? 'checked="checked"': '');
    $disabled = (($disable_condition) ? 'disabled="disabled"': '');
    $additional_classes = ('' != $add_classes ? ' ' . $add_classes : '');
    return( sprintf("%s<input id='%s' class='cbx%s' value='1' type='checkbox' %s %s/> %s%s\n",
    _indentt($indent), $id, $additional_classes, $checked, $disabled, __($label, $navt_domain), $brafter ? '<br />':''));
}

function tbox() {
}



/**
 * Temporary upgrade fix for pre-95.38 versions
 * Establishes the page/category levels
 *
 * @param array $itm
 */
function fix_level($itm) {
    $level = '0';

    if( $itm[TYP] == TYPE_CAT ) {
        $level= NAVT::get_category_level($itm[IDN]);
    }
    else if( $itm[TYP] == TYPE_PAGE ) {
        $level = NAVT::get_page_level($itm[IDN]);
    }

    return($level);
}

/**
 * Add hidden storage variables to the item
 *
 * @param string $id
 * @param array $itm
 * @param integer $in
 * @return string - formatted html string
 * @since 95.38
 */
function NAVT_add_storage_items($id, $itm, $in) {
    $opt =  ($itm[OPT] & HAS_DD_OPTION) ? intval($itm[OPT]) ^ HAS_DD_OPTION : intval($itm[OPT]);
    $sfmt  = "%s<input type=\"hidden\" class=\"%s\" id=\"%s\" value=\"%s\"/>\n";
    $html  = sprintf($sfmt, _indentt($in), NME, $id.ID_SFX_NME, $itm[NME]); // alias
    $html .= sprintf($sfmt, _indentt($in), TTL, $id.ID_SFX_TTL, $itm[TTL]); // url
    $html .= sprintf($sfmt, _indentt($in), OPT, $id.ID_SFX_OPT, $opt);      // options
    $html .= sprintf($sfmt, _indentt($in), EXT, $id.ID_SFX_EXT, $itm[EXT]); // extra options
    $html .= sprintf($sfmt, _indentt($in), LVL, $id.ID_SFX_LVL, $itm[LVL]); // item level
    $html .= sprintf($sfmt, _indentt($in), EX2, $id.ID_SFX_EX2, $itm[EX2]); // extra options
    return($html);
}

/**
 * Add common controls to an item
 *
 * @param string $id - control id
 * @param integer $opt - control's options settings
 * @param integer $in - indentation level
 * @return string - html string
 * @since 95.38
 */
function NAVT_add_common_options($id, $opt, $itm, $in, $what ) {

    $html = '';

    if( $what == ID_SFX_ANCHOR_OPTS ) {
        $is_standard = ($opt & (TEXT_OVER_GRAPHIC | TEXT_WITH_SIDE_GRAPHIC | GRAPHIC_LINK)) ? 0: 1;
        $is_text_with_side_graphic = ($opt & TEXT_WITH_SIDE_GRAPHIC) ? 1: 0;

        $ext = $itm[EXT];
        $ext = isBlank($ext) ? '0': $ext;

        $html .= sprintf("%s<label>Anchor Display Options:</label>\n", _indentt($in));
        $html .= sprintf("%s<select id='%s' class='%s'>\n", _indentt($in), $id.ID_SFX_ANCHOR_OPTS, CLS_ANCHOR_SELECT);
        $html .= sprintf("%s<option value='%s' %s>Standard text link</option>\n", _indentt($in+1), STANDARD_LINK,
        (($is_standard) ? 'selected="selected"':''));
        $html .= sprintf("%s<option value='%s' %s>Text over graphic</option>\n", _indentt($in+1), TEXT_OVER_GRAPHIC,
        (($opt & TEXT_OVER_GRAPHIC) ? 'selected="selected"':''));
        $html .= sprintf("%s<option value='%s' %s>Text with side graphic</option>\n", _indentt($in+2), TEXT_WITH_SIDE_GRAPHIC,
        (($opt & TEXT_WITH_SIDE_GRAPHIC) ? 'selected="selected"':''));
        $html .= sprintf("%s<option value='%s' %s>Graphic link</option>\n", _indentt($in+2), GRAPHIC_LINK,
        (($opt & GRAPHIC_LINK)  ? 'selected="selected"':''));
        $html .= sprintf("%s</select><br />\n", _indentt($in));
        $html .= sprintf("%s<label id='%s_lbl' %s>Image class for side graphic:</label>\n",_indentt($in), $id.ID_SFX_IMGCLS,
        (!$is_text_with_side_graphic ? 'class="'.CLS_DISABLED.'"' : ''));
        $html .= sprintf("%s<input type=\"text\" id=\"%s\" size=\"%s\" maxlength=\"%s\" value=\"%s\" %s/><br />\n",
        _indentt($in), $id.ID_SFX_IMGCLS, MAX_ALIAS_NAME, MAX_LEN, $ext, ( (0 == $is_text_with_side_graphic) ? 'disabled="disabled"':''));
    }

    if( $what == ID_SFX_CB10) {
        // Option for temporarily removing the list item from the navt screen (bit10)
        $html = cbox( $id.ID_SFX_CB10, '', $opt & DO_NOT_DISPLAY, 0, "Do not use", $in);
    }
    if( $what == ID_SFX_CB13) {
        // Option for temporarily removing the list item from the navt screen (bit10)
        $html = cbox( $id.ID_SFX_CB13, '', ($opt & NOFOLLOW), 0, "add rel=nofollow", $in);
    }

    return($html);
}

/**
 * NAVT_make_item
 * Creates the common HTML portion of an item to be added to a group
 *
 * @param string $item_title - title used to identify the item type
 * @param string $img_class - the icon image class
 * @param string $options - HTML formatted options string to be added to the control box
 * @param integer $seq - a sequence number
 * @param array $itm - the menu item
 * @param integer $in - starting indentation value (HTML format)
 * @return string $html HTML output text
 */
function NAVT_make_item($item_title, $img_class, $options, $seq, $itm, $in)
{
    $help = NAVT::get_url() . '/'. IMG_BLANK;
    $id = NAVT_make_item_id($itm[TYP], $itm[IDN], $itm[GRP]);
    $img = sprintf("%s", NAVT::get_URL().'/'.IMG_BLANK);

    $nme = $itm[NME];
    $ttl = $itm[TTL];
    $opt_title = NAVT::truncate($nme, 15);

    $tip = sprintf("<div class='helpdiv'><a href='%s' class='navt-jTip helptip' title='' id='bt-%s'><img class='helpicon' src='%s' /></a></div>",
    NAVT::get_url() .'/app/navtip.php?tipid='.$itm[TYP].'&width='.HELP_WIDTH, $id, $help);

    // Start the HTML
    $opt = intval($itm[OPT]);
    $addcss  = ( $itm[TYP] == TYPE_PAGE && ($opt & ISDRAFTPAGE) ) ? ' ' . CLS_DRAFTPAGE : '';  // @since 95.30
    $addcss .= ($opt & ISPRIVATE) ? ' '. CLS_PRIVATE : '';  /** @since 95.30 **/
    $img_class .= $addcss;

    /** @since 95.38 **/
    $addcss .= ' '.DELIM.$itm[TYP].ISFX;
    $addcss .= ($opt & DO_NOT_DISPLAY) ? ' ' . CLS_NOSHOW: ''; /** @since 95.38 **/
    $addcss .= NAVT_set_level($itm);
    $style = sprintf("style='position:relative;%s'", ($opt & DO_NOT_DISPLAY) ? 'display:none;' : '');

    $html = '';
    $html .= sprintf("%s<%s class=\"%s %s\" id=\"%s\" %s>%s\n",_indentt($in), CLS_MSORT_TAG, CLS_PGCT, CLS_DRAG .$addcss,
    $id.ID_SFX_MENUITEM, $style, NAVT_add_hierarchy_controls($id));
    $html .= sprintf("%s<img id=\"%s\" class=\"%s %s\" src=\"%s\"/>\n", _indentt($in+1), $id.ID_SFX_IKON, CLS_MENUITEM_HANDLE, $img_class, $img);
    $html .= sprintf("%s<h4><a class=\"%s\" id=\"%s\" href=\"#\" onclick=\"return(item_click(this, 'open'));\" title=\"%s\">%s</a></h4>\n",
    _indentt($in+1), CLS_OPTBOX, $id.ID_SFX_OPTBOX, $nme, $opt_title);
    $html .= sprintf("%s<div class=\"%s\" id=\"%s\" style=\"%s\">\n", _indentt($in+1), CLS_IMENU, $id.ID_SFX_IMENU, STY_HIDDEN);
    $html .= sprintf("%s<p class=\"info\">%s \"%s\" %s </p>\n", _indentt($in+2), $item_title, $ttl, $tip);
    $html .= sprintf("%s<div class=\"options_wrapper\">\n", _indentt($in+2));
    if( !empty($options) ) {$html .= $options;}

    // controls
    $html .= sprintf("%s<label>Menu Item Alias:</label>\n",_indentt($in+3));
    $html .= sprintf("%s<input type=\"text\" id=\"%s\" size=\"%s\" maxlength=\"%s\" value=\"%s\"/><br />\n",
    _indentt($in+3), $id.ID_SFX_TXTBX, MAX_ALIAS_NAME, MAX_LEN, $nme);

    // Not for home, author or login links...
    if((HOMEIDN != $itm[IDN]) && (LOGINIDN != $itm[IDN]) && TYPE_AUTHOR != $itm[TYP]) {
        if( (TYPE_PAGE == $itm[TYP]) && ($opt & ISDRAFTPAGE) ) {
            $html .= sprintf("%s<p>-- Page Draft --</p>\n",_indentt($in+3));
        }
        else {
            // add private option
            $html .= cbox( $id.ID_SFX_CB5, '', $opt & ISPRIVATE, 0, "Private (Must login to see)", $in+3);
        }
    }

    /** @since 95.38 **/
    $html .= NAVT_add_common_options($id, $opt, $itm, $in+3, ID_SFX_CB13);
    $html .= NAVT_add_common_options($id, $opt, $itm, $in+3, ID_SFX_CB10);

    /** add ok and cancel **/
    $html .= NAVT_make_ok_can_del($id, $in+4, 1, 1, 0);

    /** add storage **/
    $html .= NAVT_add_storage_items($id, $itm, $in+3); /** @since 95.38 */
    $html .= sprintf("%s</div>\n", _indentt($in+2));
    $html .= sprintf("%s</div>\n", _indentt($in+1));
    $html .= sprintf("%s</%s>\n", _indentt($in), CLS_MSORT_TAG);

    return($html);
}

/**
 * Creates the controls for playing with the item hierarchy
 *
 * @param string $id - item id
 * @return string - html string
 * @since 95.38
 */
function NAVT_add_hierarchy_controls($id) {
    $html = sprintf("<span id='%s_inot' class=\"hier\">
                       <p class=\"outdent\"><a class=\"hbout\" id=\"%s_in\" href=\"#\" onclick=\"return(%s);\"><img src=\"%s\"/></a></p>
                       <p class=\"indent\"><a class=\"hbin\" id=\"%s_ot\" href=\"#\" onclick=\"return(%s);\"><img src=\"%s\"/></a></p></span>\n",
    $id, $id, 'outdent(this)' , NAVT::get_url() . '/'. IMG_BLANK, $id, 'indent(this)' , NAVT::get_url() . '/' . IMG_BLANK);
    return($html);
}

/**
 * NAVT_make_item_id - Create a DOM identifier for a navigation item
 *
 * @param string $iType  - type of item
 * @param string $iIdn   - identifier
 * @param string $iGroup - belongs to this group
 * @since .95.1
 *
 * Returns a formatted identifier
 */
function NAVT_make_item_id($iType, $iIdn, $iGroup) {
    return( 'a'.$iType.SEP.$iIdn.SEP.$iGroup);
}

/**
 * Sets the hierarchy level of an item by returning
 * a class.
 *
 * @param array $itm - an item from the map array
 * @since 95.38
 */
function NAVT_set_level($itm) {
    // The base level of an item always starts at the level established by the user in wordpress
    // but this is only true for pages and categories; otherwise, the level is established at zero (parent)
    return( ' ' . CLS_LEVEL . $itm[LVL]);
}

/**
 * Converts a phrase into a slug name
 * @param string $phrase - a word or several words
 */
function NAVT_clean_name($name) {

    $new = stripslashes($name);  // remove slashes
    $new = strip_tags($new); // remove any html
    $new = strtolower($new); // drop to lower case
    $new = trim($new); // trim off spaces
    $new = str_replace(" ", "", $new);
    return($new);
}

/**
 * Returns the next group scheme class
 * A similar function is written for the javascript side
 *
 * @param string $groupName - name of the current group
 */
function NAVT_getNextScheme($i) {
    $n = $i;
    while( $n > SCHEME_LIMIT) $n -= SCHEME_LIMIT;
    NAVT::update_option(SCHEME, $n);
    return(CLS_GROUP_SCHEME . $n);
}
?>