<?php
/*
** +---------------------------------------------------+
** | Name :		~/main/forum/forum_modo.php
** | Begin :	20/10/2005
** | Last :		10/12/2007
** | User :		Genova
** | Project :	Fire-Soft-Board 2 - Copyright FSB group
** | License :	GPL v2.0
** +---------------------------------------------------+
*/

/*
** Page affichant le panneau de controle de modération
** Chaque module sera pioché dans le répertoire ~/main/modo/
**
** Chaque module doit contenir une variable globale à la page nommée "show_this_module" avec comme
** valeur TRUE ou FALSE suivant si l'ont souhaite afficher le module dans le menu
*/
class Fsb_frame_child extends Fsb_frame
{
	// Paramètres d'affichage de la page (barre de navigation, boite de stats)
	public $_show_page_header_nav = TRUE;
	public $_show_page_footer_nav = FALSE;
	public $_show_page_stats = FALSE;

	// Module sellectioné pour la page
	public $module;

	// Navigation
	public $nav = array();

	// Liste des modules par défaut du forum, uniquement afin de les placer dans un certain ordre
	public $list = array('index', 'abuse', 'approve', 'calendar', 'ip', 'merge', 'move', 'procedure', 'split', 'upload', 'user', 'warn');

	/*
	** Constructeur
	*/
	public function main()
	{
		// On récupère le module du panneau à afficher
		$this->module = Http::request('module');

		if (!$this->module || !file_exists(ROOT . 'main/modo/modo_' . $this->module . '.' . PHPEXT))
		{
			$this->module = 'index';
		}

		// Le membre a le droit d'accéder à la modération ?
		if ($this->module != 'delete' && $this->module != 'procedure_exec' && Fsb::$session->auth() < MODO)
		{
			Display::message('not_allowed');
		}
		else if ($this->module != 'delete' && $this->module != 'procedure_exec')
		{
			Fsb::$tpl->set_switch('show_menu_panel');
		}

		// Cette liste sera utilisée pour afficher des informations (numéro) à côté du nom de certaines pages, histoire
		// de faciliter la lecture aux modérateurs. Par exemple : messages abusifs (xx).
		$info_list = array(
			'abuse' =>		Fsb::$session->data['u_total_abuse'],
			'approve' =>	Fsb::$session->data['u_total_unapproved'],
			'calendar' =>	Fsb::$db->get('SELECT COUNT(*) AS total FROM ' . SQL_PREFIX . 'calendar WHERE c_approve = 0 AND c_view <> 0', 'total'),
		);

		// On liste les modules du panneau de modération
		$getlist = array();
		$fd = opendir(ROOT . 'main/modo/');
		$max = 1000;
		$list = array_flip($this->list);
		while ($file = readdir($fd))
		{
			if ($file[0] != '.' && preg_match('#^modo_(.*?)\.' . PHPEXT . '$#i', $file, $match))
			{
				$getlist[$match[1]] = (isset($list[$match[1]])) ? $list[$match[1]] : $max++;
			}
		}
		closedir($fd);

		// Tri de la liste
		$getlist = array_flip($getlist);
		ksort($getlist);

		foreach ($getlist AS $m)
		{
			$show_this_module = FALSE;
			include(ROOT . 'main/modo/modo_' . $m . '.' . PHPEXT);
			if (isset($show_this_module) && $show_this_module)
			{
				Fsb::$tpl->set_blocks('module', array(
					'IS_SELECT' =>	($this->module == $m) ? TRUE : FALSE,
					'URL' =>		sid(ROOT . 'index.' . PHPEXT . '?p=modo&amp;module=' . $m),
					'NAME' =>		Fsb::$session->lang('modo_module_' . $m),
					'INFO' =>		(isset($info_list[$m])) ? $info_list[$m] : NULL,
				));

				if ($this->module == $m)
				{
					$this->nav[] = array(
						'url' =>	'',
						'name' =>	Fsb::$session->lang('modo_module_' . $m),
					);
				}
			}
		}

		Fsb::$tpl->set_vars(array(
			'MENU_HEADER_TITLE' =>	Fsb::$session->lang('modo_panel'),
		));

		// On inclu la classe du module d'utilisateur, puis on instancie
		$class_modo_module = 'Page_modo_' . $this->module;
		$modo_module = new $class_modo_module();
	}
}

/* EOF */